package uk.ac.ox.tall.wcker;

import org.eclipse.swt.layout.*;

/**
 * BustingGridData class - intended as extension of GridData class because
 *                         a common case emerged and one would like to pre-fill-in
 *                         certain values. However it transpired that GridData
 *                         is a final class and this cannot be done - the class
 *                         defined here is a compromise.
 * @author BalchD
 * @author JohnstonD
 *  
 */


// cannot exten a final class
public class BustingGridData
{

/**
 * Returns a GridData object that lays-out a "cell" within a GridLayout.
 * This "MAXes-out" a cell to fill up the remainder of space available
 * to it. This is such a common type of GridData object that a special
 * class was created.
 *
 * @return      the MAXED-OUT GridData object
 * @see		org.eclipse.swt.layout.GridData
 * @see		org.eclipse.swt.layout.GridLayout
 */
	static public GridData  getValue()
	{
		GridData bust = new  GridData();
		bust.verticalAlignment = GridData.FILL;
		bust.horizontalAlignment = GridData.FILL;
		bust.grabExcessVerticalSpace = true;
		bust.grabExcessHorizontalSpace = true;
		return bust;
	}
	static public GridData  getVerticalValue()
	{
		GridData bust = new  GridData();
		bust.verticalAlignment = GridData.FILL;
		//bust.horizontalAlignment = GridData.FILL;
		bust.grabExcessVerticalSpace = true;
		//bust.grabExcessHorizontalSpace = true;
		return bust;
	}
	static public GridData  getHorizontalValue()
	{
		GridData bust = new  GridData();
		//bust.verticalAlignment = GridData.FILL;
		bust.horizontalAlignment = GridData.FILL;
		//bust.grabExcessVerticalSpace = true;
		bust.grabExcessHorizontalSpace = true;
		return bust;
	}
}
