/*
 * Created on 19-Jan-2005
 *
 */
package uk.ac.ox.tall.wcker;

import uk.ac.ox.tall.wcker.WizardCache;
import uk.ac.ox.tall.wcker.Wizard;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.widgets.List;


/**
 * ChooseWizard class - for picking a WCKER wizard to run,
 * or load an old one to continue.
 * <p>
 * This should present a user interface allowing the user to choose 
 * a wizard, which is run using {@link Wizard}. 
 * 
 * @author BalchD
 * @author JohnstonD
 *  
 */

public class ChooseWizard {
	WizardCache wc;				// list of wizard file names

    	boolean debug = WckerSystem.doDebug();

    	Display display;			// display in whch we are operation
    	Shell shell;				//

     	List wizardList;			// List of GUI elements in Menu
	int selectedNewWizard; 			// actual wizard selected

   	Button newWizardRadio;			// radio buttion for new Wizard
 	Button continueWizardRadio;		// radio buttion to continue old Wizard

	String continueWizardPathname;
	Button continueWizardBrowse;		// BROWSE button
	Button selectButton;			// SELECT button
	Button cancelButton;			// CANCEL button
	
	Text continueWizardTextInput;		// text input widget
	DirectoryDialog directoryDialog;	// directory dialog widget if browse button pressed
	
	//*********************************** New wizard section components ***************************
	Composite addStartNewWizardSection(Shell shell) {
		// "Start a new wizard" composite
		Composite startNewWizardSectionComposite = new Composite(shell, SWT.NONE);
		startNewWizardSectionComposite.setLayout(new FormLayout());
		// Positioning within parent
		FormData startNewWizardSectionLayoutData = new FormData();
		startNewWizardSectionLayoutData.top = new FormAttachment(0,0);
		startNewWizardSectionLayoutData.bottom = new FormAttachment(100,-95);
		startNewWizardSectionLayoutData.left = new FormAttachment(0,0);
		startNewWizardSectionLayoutData.right = new FormAttachment(100,0);
		startNewWizardSectionComposite.setLayoutData(startNewWizardSectionLayoutData);
		
		return startNewWizardSectionComposite;
		
	}
	
	// Radio button to enable the existing wizard select box (a list)
	Button addNewWizardRadio(Composite composite){
		// Radio button and text prompt
		newWizardRadio = new Button(composite, SWT.RADIO);
		newWizardRadio.setText("Start a new wizard:");
		newWizardRadio.setSelection(true);
		return newWizardRadio;
	}
	
	// The list of wizards available to WCKER 
	List addWizardList (Composite composite) {
		// List of available wizards
		wizardList = new List(composite, SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL | SWT.BORDER | SWT.SINGLE );
		// Positioning within parent
		FormData wizardListLayoutData = new FormData();
		wizardListLayoutData.top = new FormAttachment(0,20);
		wizardListLayoutData.bottom = new FormAttachment(100,0);
		wizardListLayoutData.left = new FormAttachment(0,20);
		wizardListLayoutData.right = new FormAttachment(100,-3);
		wizardList.setLayoutData(wizardListLayoutData);
		
		// Add items to wizard list

		// Load up Wizard cache file	
		wc = new WizardCache( WckerSystem.getWizardDirectory() + "wwz-cache.xml" );

		// For each wizard in the cache list
		for(int i=0; i < wc.size(); ++i) {
			if (debug) {
				System.out.println("wc.size() " + wc.size());
				System.out.println("list index: " + i);
				System.out.println(wc.get(i).toString());
				System.out.println("");
			}
			//Add an item to the List widget 
			//wizardList.add(wc.get(i).toString());
			wizardList.add(((WizardCacheItem)wc.get(i)).getTitle());
			
		}
		
		return wizardList;
	}
	
	//******************* Continue wizard section components ******************
	
	Composite addContinueWizardSectionComposite(Shell shell) {
		if (debug) {
			System.out.println("Continue composite 1");
		}
		// "Continue an existing wizard" composite
		Composite continueWizardSectionComposite = new Composite(shell, SWT.NONE);
		FillLayout continueWizardSectionCompositeLayout = new FillLayout();
		continueWizardSectionCompositeLayout.type = SWT.VERTICAL;
		continueWizardSectionComposite.setLayout(continueWizardSectionCompositeLayout);
		// Positioning within parent
		FormData continueWizardSectionLayoutData = new FormData();
		continueWizardSectionLayoutData.height = 45;
		continueWizardSectionLayoutData.bottom = new FormAttachment(100,-40);
		continueWizardSectionLayoutData.left = new FormAttachment(0,0);
		continueWizardSectionLayoutData.right = new FormAttachment(100,0);
		continueWizardSectionComposite.setLayoutData(continueWizardSectionLayoutData);
		
		return continueWizardSectionComposite;
	}	
	
	// Radio button and text prompt
	Button addContinueWizardRadio(Composite composite){
		if (debug) {
			System.out.println("Continue radio");
		}
		continueWizardRadio = new Button(composite, SWT.RADIO);
		continueWizardRadio.setText("Continue an existing wizard:");
		continueWizardRadio.setSelection(false);
		return continueWizardRadio;
	}
	
	
	Composite addContinueWizardFileSelectionComposite(Composite composite) {
		if (debug) {
			System.out.println("Continue composite 2");
		}
		// Composite containingontinueWizardBrowsex and filesystem browse button 
		Composite continueWizardFileSelection = new Composite(composite, SWT.NONE); 
		continueWizardFileSelection.setLayout(new FormLayout());
		
		return continueWizardFileSelection;
	}
	
	Text addContinueWizardTextInput(Composite composite) {
		if (debug) {
			System.out.println("Continue text");
		}
		// text input
		continueWizardTextInput = new Text(composite, SWT.BORDER);
		// Positioning within parent
		FormData continueWizardTextInputLayoutData = new FormData();
		continueWizardTextInputLayoutData.top = new FormAttachment(0,2);
		continueWizardTextInputLayoutData.left = new FormAttachment(0,20);
		continueWizardTextInputLayoutData.right = new FormAttachment(100,-77);
		continueWizardTextInput.setLayoutData(continueWizardTextInputLayoutData);
		continueWizardTextInput.setEnabled(false);
		
		return continueWizardTextInput;
	}
	
	Button addContinueWizardBrowse(Shell shell, Composite composite) {
		if (debug) {
			System.out.println("Continue browse button");
		}
		// File browsing button
		continueWizardBrowse = new Button(composite, SWT.PUSH);
		continueWizardBrowse.setText("Browse");
		// Positioning within parent
		FormData continueWizardBrowseLayoutData = new FormData();
		continueWizardBrowseLayoutData.left = new FormAttachment(100,-73);
		continueWizardBrowseLayoutData.right = new FormAttachment(100,-3);
		continueWizardBrowse.setLayoutData(continueWizardBrowseLayoutData);
		continueWizardBrowse.setEnabled(false);
		
		// Create directory dialogue widget
		directoryDialog = new DirectoryDialog(shell);
		directoryDialog.setText("Select a wizard to continue");
		directoryDialog.setMessage("Select the directory of a wizard in progress.");
		
		return continueWizardBrowse;
	}
	
	
	//Select and cancel buttons components
	Composite addSelectCancelComposite(Shell shell) {
		// Select and cancel buttons composite
		Composite selectCancelComposite = new Composite(shell, SWT.NONE);
		RowLayout selectCancelCompositeLayout = new RowLayout();
		selectCancelCompositeLayout.pack = false;
		selectCancelComposite.setLayout(selectCancelCompositeLayout);
		// Positioning within parent
		FormData selectCancelLayoutData = new FormData();
		selectCancelLayoutData.height = 27;
		selectCancelLayoutData.bottom = new FormAttachment(100,0);
		selectCancelLayoutData.right = new FormAttachment(100,0);
		selectCancelComposite.setLayoutData(selectCancelLayoutData);
		
		return selectCancelComposite;
		
	}
	
	
	
	//******************************** Listeners **************************************
	
	private void addNewWizardRadioListener() {
		
		// Listen for clicks on the radio button - enable/disable sections.
		newWizardRadio.addSelectionListener(
				new SelectionAdapter() {
					public void widgetSelected(SelectionEvent e) {
						if (debug) {
							System.out.println("Selected 'Start a new wizard' radio button");
						}
						
						// On selection:
						
						///disable "continue" sections
						// DISABLED CONTINUE WIZARD
						//continueWizardRadio.setSelection(false);
						//continueWizardTextInput.setEnabled(false);
						//continueWizardBrowse.setEnabled(false);
						
						//enable "new" sections
						// DISABLED CONTINUE WIZARD
						//continueWizardRadio.setSelection(false);
						wizardList.setEnabled(true);
						
						//Enable or disable the select button, depending on whether there's an entry in the text box
						selectedNewWizard = wizardList.getFocusIndex();

						System.out.println("selected:" + selectedNewWizard);
						if (selectedNewWizard == -1 || selectedNewWizard == 0) {
							selectButton.setEnabled(false);
						} else {
							selectButton.setEnabled(true);	
						}
						
					}
				}
		);
		
	}
	private void addContinueWizardRadioListener() {
		// Listen for clicks on the radio button - enable/disable sections.
		continueWizardRadio.addSelectionListener(
				new SelectionAdapter() {
					public void widgetSelected(SelectionEvent e) {
						if (debug) {
							System.out.println("Selected 'Continue an existing wizard' radio button");
						}
						// On selection:
						
						///disable "new" sections
						newWizardRadio.setSelection(false);
						wizardList.setEnabled(false);
						
						//enable "continue" sections
						continueWizardRadio.setSelection(true);
						continueWizardTextInput.setEnabled(true);
						continueWizardBrowse.setEnabled(true);
						
						//Enable or disable the select button, depending on whether there's an entry in the text box
						continueWizardPathname = continueWizardTextInput.getText();
						if (continueWizardPathname == "") {
							selectButton.setEnabled(false);
						} else {
							selectButton.setEnabled(true);	
						}
					}
				}
				
		);
	}
	
	private void addContinueWizardBrowseListener() {
		// Listen for clicks on the browse button - open the directory dialogue widget onclick
		continueWizardBrowse.addSelectionListener(
				new SelectionAdapter() {
					public void widgetSelected(SelectionEvent e) {
						if (debug) {
							System.out.println("Clicked 'Browse' button");
						}
						String selectedDirectory = "";
						selectedDirectory = directoryDialog.open();
						if (selectedDirectory != null) {
							System.out.println("Selected directory: '" + selectedDirectory + "'.");
							continueWizardTextInput.setText(selectedDirectory);
						} else {
							System.out.println("No directory selected");
						}
					}
				}
		);
	}
	
	
	private void addSelectButtonListener() {
		// Listen for clicks on the select button - Runs WCKER with the chosen wizard.
		selectButton.addSelectionListener(
				new SelectionAdapter() {
					public void widgetSelected(SelectionEvent e) {
						if (debug) {
							System.out.println("Clicked 'Select' button ");
							System.out.println("  ListItem: " + wizardList.getFocusIndex());
							// DISABLED CONTINUE WIZARD
							//System.out.println("  TextInput: " + continueWizardTextInput.getText());
						}
						// Action: Run WCKER with the chosen wizard.
						String wizardFile;
						
						// Get file specified
						if (newWizardRadio.getSelection() == true){
							// Start new wizard
							int wizard_index = wizardList.getSelectionIndex();
							WizardCacheItem wi = (WizardCacheItem) wc.get(wizard_index);
							if (debug) {
								System.out.println("A new wizard is selected (index=" 
										+ wizard_index + "|" + 	wizardList +  "|"
										+ ": '"); // + wizardFile + "'");
							}
							wizardFile = wi.getFile();
							
						} else {
							// Continue existing wizard course
							// DISABLED CONTINUE WIZARD
							wizardFile = null;
							/*
							if (debug) {
								System.out.println("An existing wizard course is selected: " + continueWizardTextInput.getText());
							}
							wizardFile = continueWizardTextInput.getText();
							*/
						}
						
						// Close this window
						shell.dispose();
						
						// Run WCKER with the chosen wizard package
						InitiateWizard myWizard = new InitiateWizard(shell, wizardFile);
						
					}
					
				}
		);
	}
	
	private void addCancelButtonListener() {
		// Listen for clicks on the cancel button - close the wizard.
		cancelButton.addSelectionListener(
				new SelectionAdapter() {
					public void widgetSelected(SelectionEvent e) {
						if (debug) {
							System.out.println("Clicked 'Cancel' button");
						}
						// Close Chooser
						display.dispose();
					}
				}
		);
	}
	
	private void addWizardListListener() {
		// Listen for clicks on any of the listed wizards
		wizardList.addSelectionListener(
				new SelectionAdapter() {
					public void widgetSelected(SelectionEvent e) {
						int i = wizardList.getSelectionIndex();
						Widget w = e.item;
						if (debug) {
							
							System.out.println("Selected a wizard index = " + i );
						}
						// Now we have chosen a wizard, enable the select button
						selectButton.setEnabled(true);
					}
				}
		);
	}
	
	private void addContinueWizardTextInputListener() {
		// Listen for an entry in the text input
		continueWizardTextInput.addModifyListener(
				new ModifyListener() {
					public void modifyText(ModifyEvent e) {
						if (debug) {
		//					System.out.println("Entered text into continueWizardTextInput");
							System.out.println(continueWizardTextInput.getCharCount() > 0);
						}
						if (continueWizardTextInput.getCharCount() > 0) {
							// Now we have some text, enable the select button
							//*
							// * TODO: We need entry validation of this text at some point,
							// * to ensure that it points to a real wizard course - 
							// * Proabably after hitting the "Select" button
							// * 
							selectButton.setEnabled(true);
						} else {
							selectButton.setEnabled(false);
							
						}
					}
				}
		);
	}
	

	public static void main (String[] args) {
		new ChooseWizard(args);
	}

	//******************************** Main **************************************
	
	ChooseWizard(String[] args) {
		
		// Define some widgets
		
		if (debug) {
			System.out.println("ChooseWizard class started");
		}
		// Create a new SWT display - which appears as a window
		display = new Display ();
		shell = new Shell (display);		// create window on display
		
		// Set the position and size of the new window
		// TODO: Should we take the available screen size into account?
		shell.setBounds (10, 10, 350, 400 );
		shell.setText("Choose a Wizard");
		
		//Assign a Layout to our shell
		shell.setLayout(new FormLayout());
		
		//*
		// * Add Wizard chooser components:
		// *
		
		// Choose a new wizard
		Composite startNewWizardSectionComposite = addStartNewWizardSection(shell);
		//Add StartNewWizardSection radio button
		Button newWizardRadio = addNewWizardRadio(startNewWizardSectionComposite);
		
		//Add list of wizards
		//*
		// * TODO: Have to setup so that a "Please wait, checking for available wizards" 
		 //* message is shown. After the wizard cache/available wizards are checked,
		 //* display them.
		 //*
////////////////////		List wizardList = addWizardList(startNewWizardSectionComposite);
		wizardList = addWizardList(startNewWizardSectionComposite);


		// continue an old wizard
		// Continue section composite
		Composite continueWizardSectionComposite = addContinueWizardSectionComposite(shell);
		// Continue section Radio button
		// DISABLED CONTINUE WIZARD
		//Button continueWizardRadio = addContinueWizardRadio(continueWizardSectionComposite);
		
		// Continue section composite with file selection text and browse button
		// DISABLED CONTINUE WIZARD
		//Composite continueWizardFileSelectionComposite = addContinueWizardFileSelectionComposite(continueWizardSectionComposite);
		//final Text continueWizardTextInput = addContinueWizardTextInput(continueWizardFileSelectionComposite);
		//Button continueWizardBrowse = addContinueWizardBrowse(shell, continueWizardFileSelectionComposite);
		
		
		//Select and cancel buttons
		Composite selectCancelComposite = addSelectCancelComposite(shell);
		
		// Select button
		selectButton = new Button(selectCancelComposite, SWT.PUSH);
		selectButton.setText("Select");
		RowData buttonRowData = new RowData(70, 20);
		selectButton.setEnabled(false);
		////////////selectButton.setLayoutData(buttonRowData);
		
		
		// Cancel button
		cancelButton = new Button(selectCancelComposite, SWT.PUSH);
		cancelButton.setText("Cancel");
		///////////cancelButton.setLayoutData(buttonRowData);
		
		//***************************  Listeners *************************
		
		addNewWizardRadioListener();
		addWizardListListener();
		// DISABLED CONTINUE WIZARD
		//addContinueWizardRadioListener();
		//addContinueWizardTextInputListener();
		//addContinueWizardBrowseListener();
		addSelectButtonListener();
		addCancelButtonListener();
		
		//**************************** Dispay the GUI ***********************
		
		// Tidy up widgets for proper layout
		//shell.pack();
		//shell.redraw();
		shell.setSize(370, 420 );

		//Open the shell, hence displaying the Chooser
		shell.open();
		
		while(!shell.isDisposed())
			if(!display.readAndDispatch())
				display.sleep();
		display.dispose();
		
	}
}
