package uk.ac.ox.tall.wcker;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;

import uk.ac.ox.tall.wcker.MyTreeItem;
import uk.ac.ox.tall.wcker.WckerTree;

/*
 *  class to inter-convert between GIU and Wcker Trees
 *  just started development
 */

class Convert
{
	private static boolean debug = WckerSystem.doDebug();

	/*
	 * We delete the ItemTree at current location with a dispose
	 *
	 * How do we insert "copy"
	 * We move down or up to get a destination
	 * we need to get the parent of the destination "spot" so we can add here (addition based on parent)
	 * we may need to add to a different child position within parent SO we have to remake from scratct
	 * ABOVE is standard case if we are not first child or lasy child
	 */
	boolean valid_landing_strip( MyTreeItem plane, MyTreeItem strip )
	{
		return true;
	}
	
	// TI -> WT
	// we are innocuously taking off a copy
	static WckerTree my_tree_item_to_wcker_tree( WckerTree parent, MyTreeItem ti ,  MyTreeItem sel_look_for)
	{
		 
		WckerTree wt = new WckerTree( parent, ( ( WckerTree) ti.payload).payload  ); // duplicate the payload	
		TreeItem[] children = ti.getItems();
	
		wt.expanded = ti.getExpanded();
		wt.selected = ( ti ==  sel_look_for);
		System.out.println( "my_tree_item_to_wcker_tree getExpanded = " + wt.expanded);
		wt.children   = new WckerTree[ children.length ];

		for(int i = 0; i < children.length; ++i)
		{
			MyTreeItem child = (MyTreeItem) children[i] ;
			wt.children[i] = my_tree_item_to_wcker_tree( wt, child , sel_look_for );
		}
		return wt;
	}
	// WT -> TI
	/* we have to do this from the top down 
	   - we cannot AVOLD creating graphic objects 
	  - we have to link into the existing TREE or start from scratch

	*/
	
	static MyTreeItem display_leaf(NeedToKnow ntn, MyTreeItem t, WckerTree wt ) //######### REVISED
	{
		MyTreeItem item = new MyTreeItem(t, wt, SWT.NONE); // just hold payloads and little else! 
		item.setText(  ( (OrganisationPayLoad) wt.payload ).nodename ); // display name from WT
		//item.setExpanded(wt.expanded);
		if ( debug )
		{
			System.out.println( "display_leaf setExpanded = " + wt.expanded);
		}
		item.setImage( WckerIcon.wcker_tree_to_image( ntn, wt ));

		return item;
	}

	static MyTreeItem wcker_tree_to_my_tree_item( NeedToKnow ntn, MyTreeItem parent,  WckerTree wt) //####### REVISED
	{		
		MyTreeItem ti = display_leaf( ntn, parent, wt);
		for(int i =0; i < wt.children.length; ++i)
		{
			wcker_tree_to_my_tree_item( ntn , ti, wt.children[i] );
		}
		//ti.setExpanded(wt.expanded);
		return ti;
	}

	static MyTreeItem display_leaf(NeedToKnow ntn, Tree t, WckerTree wt ) //######### REVISED
	{
		MyTreeItem item = new MyTreeItem(t, wt, SWT.NONE); // just hold payloads and little else! 
		item.setText(  ( (OrganisationPayLoad) wt.payload ).nodename ); // display name from WT
		//item.setExpanded(wt.expanded);
		if ( debug )
		{
			System.out.println( "top display_leaf setExpanded = " + wt.expanded);
		}
		item.setImage( WckerIcon.wcker_tree_to_image( ntn, wt ));
		
		return item;
	}

	static void expansion_descent(MyTreeItem ti, WckerTree wt)
	{
		ti.setExpanded(wt.expanded);

		TreeItem[] children = ti.getItems();
		for(int i =0; i < wt.children.length; ++i)
		{
			 expansion_descent( (MyTreeItem) children[i],  wt.children[i] );
		}
	}
	static void selection_descent(NeedToKnow ntn, MyTreeItem ti, WckerTree wt)
	{
		if ( wt.selected )
		{
			ntn.select_and_see(  ti );
		}

		TreeItem[] children = ti.getItems();
		for(int i =0; i < wt.children.length; ++i)
		{
			 selection_descent( ntn, (MyTreeItem) children[i],  wt.children[i] );
		}
	}

	static MyTreeItem wcker_tree_to_my_tree_item( NeedToKnow ntn, Tree parent, WckerTree wt) //####### REVISED
	{		
		MyTreeItem ti = display_leaf( ntn, parent, wt);
		for(int i =0; i < wt.children.length; ++i)
		{
			wcker_tree_to_my_tree_item( ntn, ti, wt.children[i] );
		}
		//ti.setExpanded(wt.expanded);
		expansion_descent(ti,wt);
		selection_descent(ntn, ti,wt);
		
		return ti;
	}
	
}

