/*
 * Created on 22-Mar-2005
 *
 * @author David Balch david.balch@conted.ox.ac.uk
 * 
 */
package uk.ac.ox.tall.wcker;

import java.util.LinkedList;

/**
 * One entry for the file export list. Contains an item and a 
 * file destination
 * @author David Balch david.balch@conted.ox.ac.uk
 *
 */
public class ExportListEntry extends LinkedList {
	String _theItem;
	String _exportType;
	String _theDest;
	String _theSource;
	boolean _filter;
	String _exportDesc;
	
	public ExportListEntry(String theItem, String exportType, String theDest, String theSource) {
		_theItem = theItem;
		_exportType = exportType;
		_theDest = theDest;
		_theSource = theSource;
		
		createExportDesc();
	}
	
	public ExportListEntry(String theItem, String exportType, String theDest, String theSource, boolean filter) {
		_theItem = theItem;
		_exportType = exportType;
		_theDest = theDest;
		_theSource = theSource;
		_filter = filter;;
		
		createExportDesc();
	}
	
	public String getItem() {
		return _theItem;
	}
	
	public String getType() {
		return _exportType;
	}
	
	public String getDestFile() {
		return _theDest;
	}
	
	public String getSourceFile() {
		return _theSource;
	}
	/**
	 * Create a string describing the export action for this entry. 
	 */
	private void createExportDesc() {
		String theDesc = "";
		
		if(_exportType.equals("copyDirectory")) {
			theDesc = "Copying directory: " + _theItem + ".";
		} else if(_exportType.equals("addDirectory")) {
			theDesc = "Exporting directory: " + _theItem + ".";
		} else if(_exportType.equals("copyFile")) {
			theDesc = "Exporting file: " + _theItem + ".";
		}
		//theDesc = theDesc + " (From " + _theSource + " to " + _theDest +".)";
		
		_exportDesc = theDesc;
	}
	public String getExportDesc() {
		return _exportDesc;
	}
}
