package uk.ac.ox.tall.wcker;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.wizard.WizardPage;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import uk.ac.ox.tall.wcker.NeedToKnow;
import uk.ac.ox.tall.wcker.Wizard;

public class GenericWckerPage extends WizardPage
{
	static boolean debug = WckerSystem.doDebug();
    private ISelection selection;
	private int page_number;
    NeedToKnow ntn;

    public GenericWckerPage(ISelection selection, NeedToKnow ntn_arg, int page_number_arg) {
    	super("wizardPage");
    	page_number = page_number_arg;
    	ntn =  ntn_arg;
    	this.selection = selection;
    }

	// actual drawing routine - with parent!
    public void createControl(Composite parent) {
    	
    	//TODO: Refactor this so that WCKER steps are built as wizardPages in 
    	//      their own right - not from part of the Wizard object. 
		Composite container = new Composite(parent, SWT.NULL);
		Wizard w = new Wizard(container,ntn,page_number); // not enough on own
		
		//Set WizardPage title
		// Arrays start at 0, but page_number starts at 1,
		// so subtract one from page_number to re-align them.  
		String stepTitle = ntn.steps[(page_number -1)].title;
		setTitle(stepTitle);
		//Set WizardPage description
		String stepDescription = ntn.steps[(page_number -1)].guidance;
		setDescription(stepDescription);
		
		//Set the control to the newly created container
		setControl(container);
    }

    private void dialogChanged() {
        updateStatus(null);
    }

    private void updateStatus(String message) {
        setErrorMessage(message);
        setPageComplete(message == null);
    }

    private void createLine(Composite parent, int ncol) {
        Label line = new Label(parent, SWT.SEPARATOR | SWT.HORIZONTAL | SWT.BOLD);
        GridData gridData = new GridData(GridData.FILL_HORIZONTAL);
        gridData.horizontalSpan = ncol;
        line.setLayoutData(gridData);
    }
}
