package uk.ac.ox.tall.wcker;


import java.io.File;

import org.eclipse.jface.wizard.*;
import org.eclipse.swt.widgets.Shell;

import uk.ac.reload.editor.contentpackaging.xml.*;

import uk.ac.ox.tall.wcker.BuildWizard;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.RGB;

public class InitiateWizard extends org.eclipse.jface.window.ApplicationWindow {

	boolean debug = WckerSystem.doDebug();
	


    protected Control createContents(Composite parent)
    {
        Shell shell = this.getShell();
        shell.setText("Personal Address Book");
	    SashForm form = new SashForm(parent, SWT.HORIZONTAL | SWT.NULL);
	    form.setWeights(new int[] {30,40,30});
	    shell.setSize(500, 300);
	return form;
   }

   	public InitiateWizard(Shell sh, String wizardFile) {
   		super(sh);

		//Create a new Wizard object, passing along the file to work with 
		if (debug) {
			System.out.println("Extracting wizard package: " + wizardFile);
		}
		
   		//Extract the wizard package
		File wizardWorkingDir = WizPackageHandler.extract_package(wizardFile);
		
		// Create a NeedToKnow object.
		NeedToKnow ntn = new NeedToKnow(wizardWorkingDir);
		
		//Build the manifest
		File targetFolder = new File(wizardWorkingDir.toString() + WckerSystem.fileSeparator() + "in-progress");
		if (debug) {
			System.out.println("manifest targetFolder: " + targetFolder);
		}
		ContentPackage cp = Wizard.build_cp(ntn, targetFolder);
		
		//Run the wizard
		run(ntn);
	}
   	
  	public void run(NeedToKnow ntn)	{
  		// Construct wizard

		if ( debug )
		{
			System.out.println(ntn.toString());
		}
  		BuildWizard wizard = new BuildWizard(ntn);
  		
  		// Open the wizard dialogue

		Shell sh = this.getShell();
  		WizardDialog dialog = new WizardDialog(sh, wizard);
		dialog.setPageSize(1000,500);
		dialog.setTitleAreaColor(new RGB(255,255,255));
		dialog.open();
  	}
}
