package uk.ac.ox.tall.wcker;

import java.io.File;
import java.io.InputStream;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;

/**
 *  simple class to hold static method
 *
 */

public class LoadXML
{
	static boolean debug = WckerSystem.doDebug();
	
	/**
	 *	Load an XML file into an in-memory Document
	 *	
	 *	param filePath the name of the XML file
	 *      return the in-memory Document object which holds the XML information 
	 *	see@ Document
	 */

	static public Document loadXml(String filePath){
		//Convert the string to a File object and pass it to the other loadXML
		File xmlFile = new File(filePath);
		return loadXml(xmlFile);
	}
	

	/**
	 *	Load an XML file into an in-memory Document
	 *	
	 *	param filePath the name of the XML file
	 *      return the in-memory Document object which holds the XML information 
	 *	see@ Document
	 */

	static public Document loadXml(File file){
		Document localXmlDocument;
		if (debug) {
			System.out.println("WizardCache.loadXml() started: " + file);
			System.out.println("    ...exists? " + file.exists());
		}
		
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		
		// TODO: Do we need to validate? - we probably should.
		//dbf.setValidating(true);
		//dbf.setAttribute("http://java.sun.com/xml/jaxp/properties/schemaLanguage", "http://www.w3.org/2001/XMLSchema");
		//String schema =  "file://home/johnstod/xerces/BookStore.xsd";
		
		// Try and load the XML file
		try
		{
			DocumentBuilder db = dbf.newDocumentBuilder();
			localXmlDocument = db.parse(file);
		}
		catch (Exception e )
		{
			localXmlDocument = null;
			System.out.println("exception" + e);
		}

		return localXmlDocument;
	}

	/**
	 *	Load an InputStream into an in-memory Document
	 *	
	 *	param filePath the name of the XML file
	 *      return the in-memory Document object which holds the XML information 
	 *	see@ Document
	 */

	static public Document loadXml(InputStream input){
		Document localXmlDocument;

		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		try
		{
			DocumentBuilder db = dbf.newDocumentBuilder();
			localXmlDocument = db.parse(input);
		}
		catch (Exception e )
		{
			localXmlDocument = null;
			System.out.println("exception" + e);
		}
		return localXmlDocument;
	}
}
