package uk.ac.ox.tall.wcker;

import uk.ac.ox.tall.wcker.MyTreeItem;
import uk.ac.ox.tall.wcker.OrganisationPayLoad;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.*;
import uk.ac.ox.tall.wcker.WckerIcon;

import org.eclipse.swt.widgets.Menu;

class TreeButtons
{	
	static boolean debug = WckerSystem.doDebug();
	Button[] gui_6_buttons = new Button[6];
	final String[] names = { "add_unit", "delete_unit", "add_page", "delete_page", "up", "down"};
	NeedToKnow local_ntn;
	int wizard_page_number;
	boolean self_insertion_mode;

	int action_to_index(String name)
	{
		for(int i = 0; i < names.length; ++i)
		{
			if ( name.equals( names	[i] ) )
			{
				return i;
			}
		}
		return -1;
	}
	void update_title_from_tree_item(NeedToKnow local_ntn, TreeItem ti)
	{
		WckerQuestion Q[] = local_ntn.steps[wizard_page_number-1].wqg.questions;
		for(int i=0;i<Q.length;++i)
		{
			//System.out.println(i + ") " + Q[i].prompt);
			if ( Q[i].prompt.indexOf("title") >= 0 )
			{
				if ( Q[i].input_area != null )
				{
					Q[i].input_area.setText( ti.getText() );
				}
			}
		}
	}






	void set_button_image( Button  b1, String local_name )
	{
		Color white = new Color( Display.getDefault() /* container.getDisplay() */,255,255,255);
			//b1.setBorderWidth(1);
			b1.setBackground( white );
			//b1.setForeground(  white );

			
			TreeItem[] ti = local_ntn.gui_tree.getSelection();
	
			boolean grey_out= false;
			if ( ti.length == 0 )
			{
if ( debug )
{
	System.out.println(" set_button_image no selection " + local_name);
}
				if ( local_name.equals("up") || local_name.equals("down")  )
				{	
					grey_out=true; // no selection to go anywhere from
				}
			}
			else
			{
if ( debug )
{
	System.out.println(" set_button_image A selection " + local_name);
}
				TreeItem down  = TreeNavigate.which_way_is_down_from_here(ti[0]);
				TreeItem up    =   TreeNavigate.which_way_is_up_from_here(ti[0]);
if ( debug )
{
	System.out.println(" set_button_image A selection " + "up = " +  up + "down = " + down);
}

				if 
				(
						( (  local_name.equals("up") ) && ( up == null ) )
						||
						( (  local_name.equals("down")  ) && ( down == null ) )
				)
				{
					grey_out=true;
				}
			}
if ( debug )
{
	System.out.println("set_button_image A grey_out = " +  grey_out);
}


grey_out = false;

			b1.setImage( WckerIcon.type_to_image( Display.getDefault() , local_name + (grey_out ? "_grey" : "") )); // genuine call of type_to_image
	}
	TreeButtons(int wizard_page_number_arg, NeedToKnow ntn, Composite composite0)
	{	wizard_page_number = wizard_page_number_arg;
		local_ntn = ntn;
		icon_menu(composite0);
	}
	/********************************************/
boolean equal_but_longer(String[] possible, String[] organisation)
{
	if ( possible.length > organisation.length )
	{
		for(int i = 0; i < organisation.length; ++i)
		{
			if ( ! possible[i].equals( organisation[i] ) )
			{
				return false;
			}
		}
		return true;
	}
	else
	{
		return false;
	}
}
String [][] select_possible_paths(String[][] possible, String[] organisation_path)
{
	boolean[] b = new boolean[ possible.length ];
	int count = 0;
	for(int i = 0;i < possible.length; ++i)
	{
		b[i] = equal_but_longer(  possible[i], organisation_path );
		if ( b[i] )
		{
			count++;
			if ( debug )
			{
				System.out.println("incremental count in select_possible_paths " + count + " " +
				WckerUtility.string_list_to_path(possible[i]) + "|" + WckerUtility.string_list_to_path(organisation_path )  ) ;
			}
		}
	}
	if ( debug )
	{
		System.out.println("final count in select_possible_paths " + count);
	}


	String[][] actual = new String[count][];
	count = 0;
	for(int i = 0;i < possible.length; ++i)
	{
		if ( b[i] )
		{
			actual[count++] = possible[i];
		}
	}


	return actual;
}

String[][] two_lists( String[][] possibles , String[] organisation_path)
{
	

	int selection_index = organisation_path.length;

	int leaf_count = 0;
	int container_count = 0;
	
	for( int i = 0; i < possibles.length; ++i)
	{
		String[] sentence = possibles[i];

		if (debug )
		{
			System.out.print("SENTENCE IN two_lists is " +	WckerUtility.string_list_to_path(sentence) + " selection_index = " + selection_index);
		}

		String word = sentence[selection_index];
		if ( ( selection_index + 1 ) == possibles[i].length ) 
		{
			// leaf node
			leaf_count++;
			
		}
		else
		{
			// container node
			container_count++;
		}
	}
	String[] containers = new String[container_count];
	String[] leaves = new String[leaf_count];
	
	leaf_count = 0;
	container_count = 0;
	for( int i = 0; i < possibles.length; ++i)
	{
		String word = possibles[i][selection_index];
		if ( ( selection_index + 1) == possibles[i].length )
		{
			// leaf node
			leaves [leaf_count++] = word;
		}
		else
		{
			// container node
			containers[container_count++] = word;
		}
	}
	String[][] two = { WckerUtility.make_unique(leaves) ,  WckerUtility.make_unique(containers) } ;
	return two;
}

void disable_all()
{
	gui_6_buttons[ action_to_index("add_page")].setEnabled(false);
	gui_6_buttons[ action_to_index("add_unit")].setEnabled(false);
	gui_6_buttons[ action_to_index("delete_unit")].setEnabled(false); // don't remove top node!!!
	gui_6_buttons[ action_to_index("delete_page")].setEnabled( false ); // don't remove top node!!!
	gui_6_buttons[ action_to_index("up")].setEnabled( false );
	gui_6_buttons[ action_to_index("down")].setEnabled( false );
		
}
void disable_putsch(NeedToKnow ntn, MyTreeItem ti)
{
	String[] organisation_path = ( new NodeInfo(local_ntn, ti) ).label_path();
	//String[] organisation_path =  get_organisation_path(ti);
	String[][] possibles = local_ntn.get_structure_paths_top();
	String[][] possibles2 = select_possible_paths(possibles, organisation_path); // all of possible which match organisation
	// look for possibles which are 1 longer than organisation path
	// this means the name at the end of the possible is a LEAF
	// otherwise not LAST i.e. a continer
	
	if ( debug )
	{
		System.out.println("789 possibles.length = " + possibles.length + " possibles2.length=" +  possibles2.length);
	}
	String[][] two = two_lists( possibles2 , organisation_path);



	boolean disable_containers 	= ( two[1].length == 0 );
	boolean disable_leaves 		= ( two[0].length == 0 );
	boolean can_go_up   		= TreeNavigate.which_way_is_up_from_here(ti)   != null;
	boolean can_go_down 		= TreeNavigate.which_way_is_down_from_here(ti) !=  null ;
if (debug )
{
	System.out.println("");
	System.out.println( "can_go_up = " + can_go_up + " can_go_down = " +  can_go_down);
}

	boolean can_move_up;
	boolean can_move_down;
	if ( can_go_up )
	{
		can_move_up =  ( multi_up("up",ti) != null) ;
	}
	else
	{
		can_move_up = false;
	}
	if ( can_go_down )
	{
		if ( ! can_go_up ) // must be at  top of tree
		{
			can_move_down = false; // top of tree is anchored
		}
		else	
		{
			can_move_down =  ( multi_up("down",ti) != null); // error path
		}
	}
	else
	{
		can_move_down = false;
	}

	if (debug )
	{
		System.out.println( "can_move_up = " + can_move_up + " can_move_down = " + can_move_down);
	}



	gui_6_buttons[ action_to_index("add_page")].setEnabled( ! disable_leaves );
	gui_6_buttons[ action_to_index("add_unit")].setEnabled( ! disable_containers );
	gui_6_buttons[ action_to_index("delete_unit")].setEnabled(  (possibles2.length > 0)  && can_go_up    ); // don't remove top node!!!
	gui_6_buttons[ action_to_index("delete_page")].setEnabled(  (possibles2.length == 0) && can_go_up    ); // don't remove top node!!!
	gui_6_buttons[ action_to_index("up")].setEnabled( can_move_up );
	gui_6_buttons[ action_to_index("down")].setEnabled( can_move_down );

	if (debug )
	{
		System.out.println("PAGE ENABLED = " + (! disable_leaves)  + "CONTAINER ENABLED = " + (! disable_containers) );
	}
	 
}

	/********************************************/
	void update_6_buttons(NeedToKnow ntn, TreeItem ti)
	{
		if ( debug )
		{
			System.out.println("REDRAW 4 BUTTONS");
		}
		disable_putsch(ntn,  (MyTreeItem) ti);
		if ( ntn.pn != null )
		{
			ntn.pn.disable_two( (MyTreeItem) ti);
		}
/****
		for(int j = 0; j < 6; ++j)
		{
			String button_name = names[j];
			set_button_image( gui_6_buttons[j], button_name );
		}
*****/
	}
String treeitem_to_type( MyTreeItem ti)
{
	Object o = ti.payload;
	WckerTree wt = ((WckerTree) o);
	OrganisationPayLoad opl = (OrganisationPayLoad) ( wt.payload );
	String type = opl.type;
	return type;
}

String[] get_organisation_path_babel_fish( MyTreeItem ti)
{
	String type = treeitem_to_type( ti);
	MyTreeItem ti2 = ti;
	int index = 1;
	while ( ( ti2 = (MyTreeItem) ti2.getParentItem() ) !=  null)
	{	
		System.out.println("CLEVER ALGORITHM winding up = " + treeitem_to_type( ti2 ));
		index++;
	}
	int count = index;
	String[] path = new String[count];

	index = count - 1;
	path[index] = type;
	ti2 = ti;
	while ( ( ti2 = (MyTreeItem) ti2.getParentItem() ) !=  null)
	{	
		index--;
		path[index] = treeitem_to_type( ti2 );
		System.out.println("CLEVER ALGORITHM winding down = " + treeitem_to_type( ti2 ));
	}
	


	

	System.out.print("CLEVER_ALGORITHM count = " + count + "path =");
	for(int i=0;i<path.length;++i)
	{
		System.out.print("\\" + path[i]);
	}
	System.out.println("");

	return path;
}


	Object[][] f_3D_to_2D( Object[][][] o )
	{
		int count = 0;
		for(int i = 0; i < o.length; ++i)
		{	
			count += o[i].length;
		}
		Object[][] o2 = new Object[count][];
		int l = 0;
		for(int i =0; i <o.length; ++i)
		{	
			for(int j =0; j < o[i].length; ++j)
			{
				
				o2[l] = o[i][j];
				l++;
			}
		}
		return o2;
	}

	


	String[][] clever_wrapper()
	{
		TreeItem[] ti = local_ntn.gui_tree.getSelection();
		if ( ti.length > 0 )
		{
			NodeInfo ni = new NodeInfo(local_ntn, (MyTreeItem) ti[0] );

			if ( debug )
			{
				String type = ni.type();
				if ( debug )
				{
					System.out.println("Thu Mar 17: " + type);	
				}
			}

			CleverReturn cr = ni.clever_algorithm();

			self_insertion_mode = cr.get_self_insertion_mode();
			return cr.get_user_choice();
		}
		else
		{
			String[][] r = new String[][]{ new String[0], new String[0] };
			return r;
		}
	}
	Menu create_pop_up( Composite composite0, final String[] menu_item_names)
	{
		Menu popupmenu = new Menu(composite0.getShell(), SWT.POP_UP | SWT.BAR  );
		// String[] menu_item_names = { "Course", "Unit", "Page" };
		for( int i = 0 ; i < menu_item_names.length; ++i)
		{	
		// CHECK, CASCADE, PUSH, RADIO, SEPARATOR
			MenuItem buttonItem = new MenuItem(popupmenu,  SWT.PUSH);
			buttonItem.setText("Add " + menu_item_names[i]);
			buttonItem.addListener
			(
				SWT.Selection, 
				new Listener()
				{
					public void handleEvent(Event e)
					{
						Widget w  = e.widget;
						MenuItem mi = (MenuItem)  e.widget;
					
						//System.out.println("Button Action Performed " + "|" + w.getData()  + "|");
						//System.out.println("Button Action Performed " + "|" +  w + "|");
						//System.out.println("Button Action Performed " + "|" +  mi + "|");
						if ( debug )		
						{
							System.out.println("Button Action Performed " + "|" +  mi.getText() + "|");
						}
						
						// XXXX We want to ACTUALLY INSERT here after menu choice
						
						TreeAction.insert(local_ntn,  mi.getText().substring(4), menu_item_names, self_insertion_mode);
					}
		
				}
			);

			////buttonItem.setSelection( i == 2 );
		}
		return popupmenu;
	}

	Point menu_size(Menu m)
	{
		int font_height = 30;
		int font_width  = 8;
		MenuItem[] mis = m.getItems();
		int max_len = 0;
		for(int i = 0; i < mis.length; ++i)
		{
			int len = mis[i].getText().length();
			if  ( len > max_len )
			{	
				 max_len = len;
			}
		}
		return new Point( max_len * font_width , mis.length * font_height);
		
	}
	/* we want to do global "in situ" copy" preserving expanded status */

	void update_org_wt_from_gui()
	{
		TreeNavigate.collect_expanded_status_top(local_ntn);
		TreeItem[] sel = local_ntn.gui_tree.getSelection();
		MyTreeItem   sel_look_for;

		if ( sel.length > 0 )
			sel_look_for =( MyTreeItem) sel[0];
		else
			sel_look_for =  (MyTreeItem) null;

		TreeNavigate.collect_selected_status_top(local_ntn, sel_look_for);
	}
	void redraw_all()
	{
		//local_ntn.gui_tree.setRedraw(false) ;
		local_ntn.gui_tree.removeAll();
		MyTreeItem mti = Convert.wcker_tree_to_my_tree_item( local_ntn, local_ntn.gui_tree, local_ntn.organization.children[0] );
		//local_ntn.gui_tree.setRedraw(true) ;
	}
	void redraw_all_old()
	{

		// THIS CREATES NEW WCKER TREE
		TreeItem[] ti = local_ntn.gui_tree.getItems();

		if ( debug )
		{
			System.out.print(ti.length + "TreeItems at top level in redraw_all");
		}

		if ( ti.length > 0 )
		{
			WckerTree wt;			

			boolean use_old_version = true;
			if (  use_old_version )
			{
				wt =  local_ntn.organization.children[0];
			}
			else
			{
				wt =  local_ntn.organization.children[0];
				//wt = Convert.my_tree_item_to_wcker_tree( (WckerTree) null, (MyTreeItem) ti[0], sel_look_for );
			}
			local_ntn.gui_tree.removeAll();
			MyTreeItem mti = Convert.wcker_tree_to_my_tree_item( local_ntn, local_ntn.gui_tree, wt );
		}
	}

	void pure_one_up( String direction, WckerTree src_wt, WckerTree dst_wt)
	{

			WckerTree dst_parent_wt = dst_wt.parent;
			WckerTree src_parent_wt = src_wt.parent;

			if ( debug )
			{
				System.out.println("pure_one_up START " + src_parent_wt.hashCode() + " " + dst_parent_wt.hashCode() );
				System.out.println("pure_one_up START " + src_wt.parent.hashCode() + " " + dst_wt.parent.hashCode() );
			}


			/* if we are children on the same parent
			   add above the dst
			 */
			if ( dst_parent_wt == src_parent_wt )
			{
				WckerTree parent_wt = dst_parent_wt;

				int dst_index = -1;
				int src_index = -1;
				for(int i = 0; i < parent_wt.children.length; ++i)
				{		
					if ( parent_wt.children[i] == src_wt)
					{
						 src_index = i;
					}
					if (  parent_wt.children[i] == dst_wt)
					{
						 dst_index = i;
					}
				}
				if ( ( src_index == -1 ) || ( dst_index == -1 ) )
				{
					System.out.println("ERROR index confuding for MOVING\n");
				}
				else
				{
					/*
							we want to clone organisational tree
							
		                         */
if ( debug )
{
	System.out.println("pure_one_up src_index = " + src_index  + " dst_index = " + dst_index);
}

				 	WckerTree tmp 			= parent_wt.children[src_index];
					parent_wt.children[src_index] 	= parent_wt.children[dst_index];
				 	parent_wt.children[dst_index]   = tmp;
				}
			}
			else
			{
				/* simply put src inside dst
					above dst gemetrically


					get parent of dst
					find index of dst in parent
					place src jus before

				*/
				/************ CUT ONE OUT OF SOURCE ******************/
				WckerTree src_parent = src_wt.parent;
				WckerTree[] new_src_children =  new WckerTree[src_parent.children.length - 1];
				int j = 0;
				for(int i = 0; i < src_parent.children.length; ++i)
				{
					if ( src_parent.children[i] !=  src_wt )
					{
						new_src_children[j++] = src_parent.children[i];
					}
				}
				src_parent.children = new_src_children;
				/***********INSERT ONE INTO DESTINATION *******************/	
				WckerTree dst_parent = dst_wt.parent;
				WckerTree[] new_dst_children =  new WckerTree[dst_parent.children.length + 1];
				j = 0;
				for(int i = 0; i < dst_parent.children.length; ++i)
				{
					
					boolean match        =  dst_parent.children[i] ==  dst_wt;

					if ( match )
					{
						src_wt.parent =  dst_parent;
						if ( direction.equals("up") )
						{
							boolean last_element = ( i == (dst_parent.children.length-1) );
							if ( last_element )
							{	
								new_dst_children[j++] = dst_parent.children[i];
								new_dst_children[j++] = src_wt; /// below if last one
							}
							else
							{
								new_dst_children[j++] = src_wt; /// by default go above
								new_dst_children[j++] = dst_parent.children[i];
							}
						}
						if ( direction.equals("down") )
						{
							boolean first_element = ( i == 0 );
							if ( first_element )
							{	
								new_dst_children[j++] = src_wt; /// above if 1st
								new_dst_children[j++] = dst_parent.children[i];
							}
							else
							{
								new_dst_children[j++] = dst_parent.children[i];
								new_dst_children[j++] = src_wt; /// by default go below
							}
						}
					}
					else
					{
						new_dst_children[j++] = dst_parent.children[i];
					}
				}
				dst_parent.children = new_dst_children;
				/*** check out tree 
					WckerTree root = src_wt.get_root_node();
					String[][] possible_type_sequences =  local_ntn.get_structure_paths_top();
					//////////String[][] actual_type_sequences   =  NeedToKnow.get_structure_paths(root,0); // nihilistic
				
					System.out.println("11111111111111111111111111111111111111111");
					 System.out.println(  WckerUtility.string_list_list(possible_type_sequences) );
					System.out.println("33333333333333333333333333333333333333333");
					////////////WckerUtility.string_list_list(actual_type_sequences);
					System.out.println( root.getName() + " " +  root.children.length);
			***/
				

			}

	
	}
	WckerTree clone_org( WckerTree org_in)
	{
		WckerTree org_out = org_in.dup( (WckerTree) null );
		//return org_in;
if ( debug )
{
		System.out.println("79521");
		System.out.println( org_in.toString() );
		System.out.println("79521");
		System.out.println( org_out.toString());
		System.out.println("79521");
}
		
		return org_out;
	}
	
	int[] telephone0( int[] seq, WckerTree tree, WckerTree item)
	{	
		if ( tree == item )
			return seq;

		int[] seq2 = new int[ seq.length + 1];

		for(int i = 0; i < seq.length; ++i)
		{
			seq2[i] = seq[i];
		}

		for(int i=0;i<tree.children.length;++i)
		{
			seq2[seq.length] = i;
			int[] res = telephone0( seq2, tree.children[i], item);
			if ( res.length > 0 )
			{
				return res;
			}
		}
		return new int[0];

	}

	WckerTree look_up_by_telephone(WckerTree tree, int[] telephone)
	{
		WckerTree acc = tree;
		for(int i = 0;  i < telephone.length; ++i)
		{
			acc = acc.children[ telephone[i] ];
		}
		return acc;
	}
	int[] telephone(WckerTree tree, WckerTree item)
	{	
		return  telephone0(new int[0], tree, item);
	}

	String iats(int[] a)	
	{
		String acc = "";
		for(int i = 0; i < a.length;++i)
		{
			acc += "," + a[i];
		}
		return acc;
	}
	boolean obeys( String[] sentence, String[] rule )
	{
		if ( rule.length < sentence.length )
			return false;

		for ( int i = 0; i < sentence.length ; ++i)
		{
			if (  ! sentence[i].equals( rule[i] ) )
				return false;
		}
		return true;
	}
	boolean valid_sentence( String[] sentence,  String[][] rules)
	{
		for(int j = 0; j < rules.length; ++j)
		{		
			String[] rule =  rules[j];
			if (  obeys(sentence,rule) )
			{
				return true;
			}
		}
		return false;
	}
	boolean big_verdict( String[][] actual_type_sequences,  String[][] possible_type_sequences)
	{
		if ( debug )
		{
			String s = WckerUtility.string_list_list(actual_type_sequences);
			System.out.println(" nihilistic one_up 2 check " + s ) ;
		}
		/*
                * determines whether a tree is valid
		* the inputs are the type sequences of leaf nodes ONLY
		* however this is sufficient to cover all container nodes as 
		* these (by definition) must be subsequences!
		*
	        */
		for(int i = 0 ; i < actual_type_sequences.length; ++i)
		{
			String[] sentence = actual_type_sequences[i];
			String[][] rules  = possible_type_sequences;

			if ( ! valid_sentence(sentence, rules ) )
			{
				return false;
			}
		}	
		return true;
	}
	WckerTree one_up(String direction, NeedToKnow local_ntn, TreeItem src, TreeItem dst)	// selected item
	{

			WckerTree src_wt = (WckerTree) (( (MyTreeItem ) src).payload);
			WckerTree dst_wt = (WckerTree) (( (MyTreeItem ) dst).payload);
			return one_up_wt( direction, local_ntn,  src_wt, dst_wt);
	}
	void print_telephone(    int[] l)
	{
		String telephone =  iats( l  );
if ( debug )
{
		System.out.println("pure telephone " +  telephone );
}
	}
	
	
	WckerTree look_up( WckerTree original, WckerTree copy, WckerTree wt)
	{
		 int[] l =   telephone( original, wt);
		 print_telephone(l);
		 return look_up_by_telephone( copy, l);
	}
	WckerTree one_up_wt(String direction, NeedToKnow local_ntn, WckerTree src_wt, WckerTree dst_wt)
	{

		WckerTree original = local_ntn.organization.children[0];
		WckerTree copy = original.dup( local_ntn.organization, src_wt, dst_wt);


		src_wt = look_up( original, copy, src_wt);
		dst_wt = look_up( original, copy, dst_wt);
		{
			WckerTree tmp;
			tmp = src_wt;
			while ( tmp != copy )
			{
				if ( tmp == dst_wt )
				{
					return (WckerTree) null;
				}
				tmp = tmp.parent;
			}
			tmp = dst_wt;
			while ( tmp != copy )
			{
				if ( tmp == src_wt )
				{
					return (WckerTree) null;
				}
				tmp = tmp.parent;
			}
		}
		pure_one_up(direction, src_wt,dst_wt);			// does the actual tree manipulation	

		// System.out.println(" nihilistic one_up 1 check " + copy.toString() ) ;
		String[][] actual_type_sequences = NeedToKnow.get_organisation_paths( copy, 0) ;
		String[][] possible_type_sequences =  local_ntn.get_structure_paths_top();
		boolean b = big_verdict( actual_type_sequences, possible_type_sequences);
	

		boolean 	 near_top = ( copy == dst_wt ); // we are getting above ourselves

if ( debug )
{
		System.out.println("big_verdict = " + b + " near_top = " +  near_top  
							+ " dst_wt.hashCode() = " + dst_wt.hashCode()
							+ " copy.hashCode() = " + copy.hashCode()

					 );
}
		if  ( b && ( ! near_top ) )
			return copy;
		else
			return (WckerTree) null;

		
	}
	void big_jump_up( TreeItem src, TreeItem dst)
	{
		//**** get up-y tree item ****.	
		// copy tree and duplicate next door clone !!!
		if ( dst != null )
		{
			//***** get parent of up-y path  
			TreeItem parent = dst.getParentItem();
			TreeItem[] children = parent.getItems(); 
			int previous_child_index = -1;
			for(int i = 0; i < children.length; ++i)
			{		
				if (children[i] == dst)
				{
					 previous_child_index = i - 1;
				}
			}
			if ( previous_child_index == - 1)
			{
				big_jump_up(src, TreeNavigate.which_way_is_up_from_here(dst) );
			}
			else
			{
				// SWAP TWO ARROUND in WT
				WckerTree tmp;	
				WckerTree parent_wt;
				parent_wt = (WckerTree) (( (MyTreeItem ) parent).payload);

				tmp 					   = parent_wt.children[previous_child_index];
				parent_wt.children[previous_child_index    ]  = parent_wt.children[previous_child_index + 1];
				parent_wt.children[previous_child_index + 1] = tmp;

				/*********from redraw all *******/

		//	setInsertMark(TreeItem item, boolean before) 

{
		WckerTree wt_org = local_ntn.organization;
		TreeItem[] ti = local_ntn.gui_tree.getItems();
		System.out.print(ti.length + "TreeItems at top level in redraw_all");
		if ( ti.length > 0 )
		{
			WckerTree wt = Convert.my_tree_item_to_wcker_tree( (WckerTree) null, (MyTreeItem) ti[0], (MyTreeItem) null);
			//wt = wt_org;	// have swapped around WT_ORG but not GUI Tree
			ti[0].dispose();
			MyTreeItem mti = Convert.wcker_tree_to_my_tree_item( local_ntn, local_ntn.gui_tree, wt );
		}
}	
			
				/****************/
				
				// we can actally do a tree copy now!!!!!
				// pretend it is VALID at the moment
				// we have to delete at the parent level!!!!!!
				/// however parent my be in midddle pf paremt's paremt
				// we have to draw whole thing!
				
				//WckerTree wt = Convert.my_tree_item_to_wcker_tree( (WckerTree null), src);
				
			}
		}
	}
	WckerTree multi_up(String direction, TreeItem current)
	{
		
		TreeItem dst;
		if ( direction.equals("up") )
			dst = TreeNavigate.which_way_is_up_from_here(current);
		else
			dst = TreeNavigate.which_way_is_down_from_here(current);

		while ( dst != ( TreeItem) null )
		{
			WckerTree copy = one_up( direction, local_ntn, current, dst );
			if ( copy != (WckerTree) null ) // found a valid place to go
			{
				return copy;
			}
			if ( direction.equals("up") )
				dst = TreeNavigate.which_way_is_up_from_here(dst);
			else
				dst = TreeNavigate.which_way_is_down_from_here(dst);
		}
		return (WckerTree) null; 
	}
	Composite icon_menu(final Composite composite0)
	{
		// pop up declarations start

		final Menu popupmenu_baseline = create_pop_up( composite0, new String[] { "Course", "Unit", "Page" } );

		Color red   = new Color(composite0.getDisplay(),255,0  ,0);
		Color yellow = new Color(composite0.getDisplay(),255,255,0);
		
		Color green = new Color(composite0.getDisplay(),  0,255,0);
		Color blue = new Color(composite0.getDisplay(),  0,0, 255);
		
		Color white = new Color(composite0.getDisplay(),255,255,255);
		
		//Composite container = new Composite( composite0, SWT.NONE); 
		final Group container = new Group( composite0, SWT.NONE); 
		
		FillLayout fl = new FillLayout(SWT.HORIZONTAL);
		container.setLayout(fl);
		
		
		//List l1 = new List(composite0, SWT.NONE); 
		
		for(int i = 0;i < names.length; ++i)
		{
			/*
			 SWT.ARROW, SWT.CHECK, SWT.PUSH, SWT.RADIO, SWT.TOGGLE, SWT.FLAT, SWT.LEFT, SWT.RIGHT, SWT.CENTER
			 */
			final String local_name = names[i];

			final Button b1 = new Button(container,  SWT.FLAT);
			gui_6_buttons[i] = b1;

			set_button_image( /*container,  */ b1, local_name );


			if ( local_name.equals("add_page") || local_name.equals("add_unit") )
			{
					b1.addMouseListener
					(	
						new MouseAdapter() 
						{
							public void mouseDown(MouseEvent e)
							{
								// XXXX WHERE WE WANT MENU TO POP UP - when mouse button goes down inside "ADD"
								Menu popupmenu;
								int index;
								if ( local_name.equals("add_unit") )
								{
									index = 0;
								}
								else
								{
									index = 1;
								}
								String[] choices = clever_wrapper()[index];	
								
								if ( choices.length == 1 )
								{
// if one one cboice insert directly with no pop-up
TreeAction.insert(local_ntn,  choices[0], choices, self_insertion_mode);

								}
								else
								{
									if ( choices.length > 0 )
									{
										popupmenu = create_pop_up(composite0,choices);
									}
									else
									{
										popupmenu = popupmenu_baseline;
									}
								
								
									popupmenu.setEnabled(true);
									popupmenu.setVisible(true);
									Point p = popupmenu.getDisplay().getCursorLocation();
									Point s = menu_size(popupmenu); // no getSize() method!
if (debug )
{
System.out.println("MENU SIZE + " + s.x + " " + s.y );
}
									popupmenu.setLocation(p.x - (s.x / 2 ) ,p.y - ( s.y / 2) );
									//popupmenu.setLocation(e.x,e.y);
if (debug)
{
									System.out.println("Mouse Down in Button");
}
				
									/////////////////////////popupmenu.setDefaultItem( popupmenu.getItem(2) );
				
									Decorations d = popupmenu.getParent() ;
									Point p2 = d.getSize();
if (debug)
{
									System.out.print("Decorations = " + p2 );
				
									System.out.print("popupmenu.getDisplay.getClientArea() = " +popupmenu.getDisplay().getClientArea() );
									System.out.print("popupmenu.getDisplay.getBounds() = " +popupmenu.getDisplay().getBounds() );	
}
								}	
							}
						}
					);
		
			}

			b1.addSelectionListener
			( 
				new SelectionListener()
				{
					public void widgetSelected(SelectionEvent e) // one of 6 buttons selected
					{
						TreeItem[] ti = local_ntn.gui_tree.getSelection();
						if ( ti.length > 0 )
						{
							boolean erronious_interpretation = false;
							
							if ( erronious_interpretation )
							{
								TreeItem next = null;
								if ( local_name.equals("down") )
								{
									next = TreeNavigate.which_way_is_down_from_here(ti[0]);
								}
								else if ( local_name.equals("up") )
								{	
									next = TreeNavigate.which_way_is_up_from_here(ti[0]);
								}
								if ( next != null )
								{

									local_ntn.select_and_see(next);

									//icon_menu(composite0);

									//gui_4_buttons.redraw();
								}
							}
							else
							{

								if ( local_name.equals("up") )
								{	
									update_org_wt_from_gui();
									WckerTree copy = multi_up("up",ti[0]);
									if ( copy != ( WckerTree) null )
									{
										local_ntn.organization.children[0] = copy;
										redraw_all();
									}
								}
								
								if ( local_name.equals("down") )
								{
									update_org_wt_from_gui();
									boolean original_code = false;
				if ( original_code )
				{
					local_ntn.organization.children[0] = local_ntn.organization.children[0].dup(local_ntn.organization);
					redraw_all();
				}
				else
				{
									WckerTree copy = multi_up("down",ti[0]);
									if ( copy != ( WckerTree) null )
									{
										local_ntn.organization.children[0] = copy;
										redraw_all();
									}
			
				}									
									
								}
								
							}
							if ( local_name.equals("add_page") ||  local_name.equals("add_unit")  )
							{

								NodeInfo ni = new NodeInfo( local_ntn, (MyTreeItem) ti[0] );
								String type =  ni.type();
if( debug )
{
								System.out.println("Thu Mar 17: " + type);
}
								ni.clever_algorithm();

								/*** adding simple page by default - not used in anger ****/
								TreeItem new_item = new TreeItem(ti[0], SWT.NONE);
								new_item.setText("new");
								new_item.setImage( WckerIcon.type_to_image( ti[0].getDisplay(), "page" )); // genuine place-holding use
							}
							
							if ( local_name.equals("delete_page") ||  local_name.equals("delete_unit")  )
							{
								TreeAction.delete( local_ntn,  (MyTreeItem) ti[0] );
							}

							
						}
						if ( debug )
						{
							System.out.println(local_name + " ICON button pressed");
						}
					}
					public void widgetDefaultSelected(SelectionEvent e) 
					{
						if (debug )
						{
							System.out.println("Default Selection Event");
						}
					}
				}

			);
		}
		
		return container;
		
	}

}