package uk.ac.ox.tall.wcker;
import org.eclipse.swt.widgets.*;

class TreeNavigate
{
	static boolean debug = WckerSystem.doDebug();
	static TreeItem get_next_sister(TreeItem ti)
	{
		TreeItem p = ti.getParentItem();
		if ( p != null )
		{
			TreeItem[] d = p.getItems(); 
			int sister = d.length;
			for ( int i = 0 ; i < d.length; ++i)
			{
				if ( ti == d[i] )
				{
					sister = i + 1;
				}
			}
			if ( sister >= d.length )
			{
				return get_next_sister(p);
			}
			else
			{
				return d[sister];
			}
		}
		return p;
	}
	static TreeItem get_first_daughter(TreeItem ti)
	{
		return ( ti.getItems() )[0];
	
	}
								
								
	static TreeItem get_last_daughter(TreeItem ti)
	{
		TreeItem[] d2 = ti.getItems(); 
		return d2[d2.length - 1];
	
	}
	static TreeItem get_prev_sister(TreeItem ti)
	{
		TreeItem p = ti.getParentItem();
		if ( p != null )
		{
			TreeItem[] d = p.getItems(); 
			int sister = -1;
			for ( int i = 0 ; i < d.length; ++i)
			{
				if ( ti == d[i] )
				{
					sister = i - 1;
				}
			}
			if ( sister < 0 )
			{
				return p;
			}
			else
			{
				if ( d[sister].getExpanded() )
				{
					return get_last_daughter( d[sister] );
				}
				else
				{
					return d[sister];
				}
			}
		}
		return p;
	}


	static TreeItem which_way_is_down_from_here(TreeItem ti)
	{
		if ( ti.getExpanded() )
		{
			return get_first_daughter( ti);
		}
		else 
		{
			return get_next_sister(ti);
		}
	}
	static TreeItem which_way_is_up_from_here(TreeItem ti)
	{
		return get_prev_sister(ti);
	}
	static void collect_expanded_status_top(NeedToKnow local_ntn)
	{
		TreeItem[] ti = local_ntn.gui_tree.getItems();
		for(int i=0;i<ti.length;++i)
		{
			collect_expanded_status(ti[i]);
		}
	}

	static void collect_expanded_status(TreeItem ti)
	{
		WckerTree wt = (WckerTree) (( (MyTreeItem ) ti).payload);	
		wt.expanded = ti.getExpanded();


		TreeItem[] ti2 = ti.getItems();
		for(int i=0;i<ti2.length;++i)
		{
			collect_expanded_status(ti2[i]);
		}
	}
/************/
	static void collect_selected_status_top(NeedToKnow local_ntn, MyTreeItem current_item )
	{
		TreeItem[] ti = local_ntn.gui_tree.getItems();
		for(int i=0;i<ti.length;++i)
		{
			collect_selected_status(ti[i], current_item);
		}
	}

	static void collect_selected_status(TreeItem ti, MyTreeItem current_item )
	{
		WckerTree wt = (WckerTree) (( (MyTreeItem ) ti).payload);	
		wt.selected = ( ti == current_item );

		if ( debug )
		{
			System.out.println("248 wt.selected = " + wt.selected);
		}

		TreeItem[] ti2 = ti.getItems();
		for(int i=0;i<ti2.length;++i)
		{
			collect_selected_status(ti2[i], current_item );
		}
	}
/************/
}
