/*
 * Created on 19-Jan-2005
 */
package uk.ac.ox.tall.wcker;

import java.io.IOException;

/**
 * The basic entry point to the Wizard Construction Kit Extension for Reload (WCKER).
 * <p>
 * This should set up any global/runtime variables, then either:<br/>
 * <ol>
 *  <li>Load a wizard specified on WCKER invocation (TODO) in {@link Wizard}, or</li>
 *  <li>Launch {@link ChooseWizard}, to select a wizard.</li>
 * </ol>
 * 
 * @author BalchD
 *
 */

public class Wcker {
	static boolean debug = WckerSystem.doDebug();

	public Wcker()
	{

		String[] args = new String[0];
		System.out.println("No argument Wcker constructor");
		
		Wcker.main(args);
	}
	
	public static void main (String [] args) {		
		if (debug) {
			System.out.println("Wcker class started");
		}
		
		//Load the WckerSystem class, to get properties set up
		try {
			WckerSystem.main(args);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		//Run the ChooseWizard class.
		new ChooseWizard(args);
	}
}
