package uk.ac.ox.tall.wcker;

import org.w3c.dom.Node;

/**
 * WckerInput class - represents the <input> element in the XML
 *                    forms part of the NeedToKnow object
 * @author BalchD
 * @author JohnstonD
 *  
 */


/*
	The XML file looks like:



		inputs
			input target1111= type 2222= 
				[ outputAttribute name=3333 value=4444 ]
				<defaultValue>5555

	The digit sequences XXXX above and below show corresponding
	locations in the XML file and java variables to hold these values

*/


public class WckerInput
{
	String target;			// 1111
	String type;			// 2222
	String outputAttribute_name;    // 3333
	String outputAttribute_value;   // 4444
	String default_value;           // 5555

	/**
	 * texutal dump of WckerInput object for debugging purposes
         */
	public String toString()
	{
		String  acc = "";
		acc +=  "TARGET: " + target + "\n";
		acc +=  "TYPE: " + type + "\n";
		acc +=  "outputAttribute_NAME: " + outputAttribute_name + "\n";
		acc +=  "outputAttribute_VALUE: " + outputAttribute_value + "\n";
		acc +=  "default_VALUE: " + default_value + "\n";
		return acc;

	}
	/**
	*	create WckerInput object from input node
	*
	*	@param n input node
	*/
	WckerInput(Node n) // input node
	{
		try
		{
			target = n.getAttributes().getNamedItem("target").getNodeValue();
		}
		catch (Exception e)
		{
			target = "";
		}
		try
		{
			type = n.getAttributes().getNamedItem("type").getNodeValue();
		}
		catch (Exception e)
		{
			type = "";
		}
		

		String[] path = { "outputAttribute" };
		Node[] ns = Navigate.elements_by_path(n, path);

		if ( ns.length > 0 )
		{
			outputAttribute_name = ns[0].getAttributes().getNamedItem("name").getNodeValue();
			outputAttribute_value = ns[0].getAttributes().getNamedItem("value").getNodeValue();
		}

		String[] path2 = { "defaultValue" };
		Node[] ns2 = Navigate.elements_by_path(n, path);

		try
		{
			default_value = ns2[0].getChildNodes().item(0).getNodeValue();
		}
		catch ( Exception e)
		{
			default_value = "";
		}	
	}

	
}

