package uk.ac.ox.tall.wcker;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Label;
/**
 * WckerQuestion class - represents the <question> element in the XML
 *                       forms part of the NeedToKnow object
 * @author BalchD
 * @author JohnstonD
 *  
 */

public class WckerQuestion
{
	/** GUI INPUT STUFF **/
	Text   input_area;
	Label  prompt_area;
	/*********************/
	String prompt   = "";
	String guidance = "";
	String answer   = "";
	WckerInput[] inputs;
	/**
	 * produces textual dump of WckerQuestion object for debugging purposes
	 *
	 * @return textual dump as a String
	 */
	public WckerQuestion dup()
	{
		WckerQuestion wq = new WckerQuestion();
				wq.input_area = input_area;
				wq.prompt_area = prompt_area;
		wq.prompt = new String(prompt);
		wq.guidance = new String(guidance);
		wq.answer = new String(answer);	
		wq.inputs = new WckerInput[ inputs.length ];
		for(int i=0;i<inputs.length;++i)
		{
			wq.inputs[i] = inputs[i];
		}
		return wq;
	}
	public String toString()
	{
		String acc = "";
		acc +=   "PROMPT: " + prompt + "\n";
		acc +=  "GUIDANCE: " + guidance + "\n";
		for(int i = 0; i < inputs.length; ++i)
		{
			acc += inputs[i];
		}
		return acc;
	}

}
