/*
 * Created on 09-Feb-2005
 *
 * @author David Balch david.balch@conted.ox.ac.uk
 * 
 */
package uk.ac.ox.tall.wcker;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

/**
 * WckerSystem - class to handle system variables.
 * e.g. those that may vary by platform
 * 
 * @author David Balch david.balch@conted.ox.ac.uk
 *
 */
public class WckerSystem {
	
	// Set the debug mode
	static int SASH_WIDTH = 5;
	static String WckerDirVar = "";
	static boolean debug = false;
	static boolean new_icon_code = true;
	private static Properties wckerProps;
	static boolean doDebug() {
		return debug;
	}
	static int getSashWidth()
	{
		return SASH_WIDTH;
	}
	static boolean doNewIconCode() {
		return new_icon_code;
	}
	public static void main(String[] args) throws IOException {
		if(debug) {
			File propLoc = new File("wcker/wcker.properties");
			System.out.println("WckerSystem class - main method");
			System.out.println(".props location: "+ propLoc.getAbsolutePath());
		}
		
		//	 create and load default properties
		Properties defaultProps = new Properties();
		FileInputStream in = new FileInputStream( "wcker/wcker.properties");
		defaultProps.load(in);
		in.close();
		
		//	 create program properties with default
		wckerProps = new Properties(defaultProps);
		
		/*
		 //	 now load properties from last invocation
		  in = new FileInputStream("user.properties");
		  wckerProps.(in);
		  in.close();
		  */
	}
	
	/**
	 * Provide convienient access to the file separator
	 */
	public static String fileSeparator() {
		return System.getProperty("file.separator");
	}
	
	/**
	 * Returns a path where icons etc to be used in the interface can be found.
	 * 
	 */
	public static String getResourceDirectory() {
		return wckerProps.getProperty("wcker.gfx.dir");
	}
	
	/**
	 * Returns a path where .wwz wizard packages are kept.
	 * 
	 */
	public static String getWizardDirectory() {
		return wckerProps.getProperty("wcker.wizards.dir");
	} 
	
	/**
	 * Returns a path where in-progress wizard files can live.
	 * 
	 */
	public static String getWorkingDirectory() {
		return wckerProps.getProperty("wcker.working.dir");
	}
	
	/**
	 * Returns a path where temporary files can live.
	 * 
	 */
	public static String getTempDir() {
		return wckerProps.getProperty("wcker.temp.dir");
	}
}
