package uk.ac.ox.tall.wcker;

import uk.ac.ox.tall.wcker.MyTreeItem;
import uk.ac.ox.tall.wcker.OrganisationPayLoad;
import uk.ac.ox.tall.wcker.SkeletonExporter;
import uk.ac.ox.tall.wcker.WckerColour;
import java.io.*;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;

import org.eclipse.swt.widgets.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.graphics.Device;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;


import org.eclipse.swt.custom.*;
import org.eclipse.swt.graphics.*;

import uk.ac.ox.tall.wcker.Help;
import uk.ac.ox.tall.wcker.WckerIcon;

import org.eclipse.swt.widgets.Tree;

import org.jdom.Element;
import org.jdom.Namespace;

import uk.ac.reload.jdom.XMLPath;
import uk.ac.reload.moonunit.schema.SchemaElement;
import uk.ac.reload.editor.contentpackaging.CP_EditorHandler;
import uk.ac.reload.editor.contentpackaging.xml.*;
import uk.ac.reload.editor.metadata.xml.MD121_SchemaController;
import uk.ac.reload.editor.metadata.xml.MD_SchemaController;

import uk.ac.ox.tall.wcker.TreeButtons;
import uk.ac.ox.tall.wcker.NodeInfo;


/**
 * class which draws the wizard on screen
 */


public class Wizard {
	
	boolean sashform_status;
	int wizard_page_number;
	static boolean debug = WckerSystem.doDebug();
	static String resourceDir = WckerSystem.getResourceDirectory();
	
	boolean do_grid = true;
	NeedToKnow local_ntn;
	int ncols = 3;
	
	/*********************************************************************************************/
	/**
	 * makes an array of buttons all the same size.
	 * i.e. making these all the same size as the largest
	 * @param b the input arrray of buttons
	 */
	public void n_buttons(Button[] b)
	{		
		int x = ( b[0].getSize() ).x; 
		int y = ( b[0].getSize() ).y;
		
		for(int i=1;i<b.length;++i)
		{
			int x2 = ( b[i].getSize() ).x; 
			int y2 = ( b[i].getSize() ).y;
			x = (x > x2) ? x : x2; 
			y = (y > y2) ? y : y2; 
		}
		for(int i=0;i<b.length;++i)
		{
			// b[i].setSize( 100, 40);
			GridData gridData = new GridData();
			gridData.heightHint = 50;
			gridData.widthHint = 50;
			gridData.heightHint = y;
			gridData.widthHint = x;
			Object o = b[i].getLayoutData();
			if ( debug )
			{
				System.out.println("o = |" + o + "|");
			}
			GridData gridData_in = (GridData) o;
			gridData_in.heightHint = y;
			gridData_in.widthHint = x;
			b[i].setLayoutData(gridData_in);
			b[i].pack();
		}
	}
	/*********************************************************************************************/
	/**
	 * makes two buttons the same size
	 * i.e. making the smaller the same size as the larger
	 * @param b0 the first button
	 * @param b1 the second button
	 */
	void two_buttons(Button b0,Button b1)
	{
		n_buttons(  new Button[] { b0, b1} );
		
	}
	/***************************************************************************/
	
	/**
	 * recursive algorithm to extract tags from a string
	 * tags are delineated by "<" and ">" thus: <TAG>
	 * @param in string from which tags have to be removed
	 * @return list of tags that have been removed
	 */
	public String[] extract_tags(String in)
	{
		int i, start, end;
		String tag, remainder;
		
		start = in.indexOf("<");
		if ( start >= 0 )
		{
			end =  in.indexOf(">");
			if ( end >= 0 )
			{	
				if ( debug )
				{
					System.out.println("-> " + start + "-->" + end + "=>" + in);
				}
				tag       = in.substring(start,end + 1);
				remainder = in.substring(end + 1);
				
				String a[] = extract_tags(remainder);
				String b[] = new String[a.length + 1];
				b[0] = tag;
				for(i=1;i<b.length;++i)
				{
					b[i] = a[i-1];
				}
				return b;
			}
		}
		return new String[0];
	}
	
	/**
	 * removes newline characters from a string
	 * @param in input string
	 * @return string with newlines removed
	 */
	public String remove_newlines(String in)
	{
		return in.replaceAll("\n","");
	}
	/**
	 * replaces <br> tags in a string with newline characters
	 * @param input string
	 * @return output string with <br> tags replace
	 */
	String special_replacement(String in)
	{
		if ( debug )
		{
			System.out.println("-----------------------------------------");
			System.out.println(in);
			System.out.println("...........................................");
		}
		in = in.replaceAll("<br[^>]*>","\n");
		if ( debug )
		{
			System.out.println(in);
			System.out.println("-----------------------------------------");
		}
		return in;
		
	}
	void display_font_data(FontData fd0[] ) 
	{
		int i;
		System.out.println("fd0 length ---->" + fd0.length);
		for(i=0;i<fd0.length;++i)
		{
			System.out.println("fd0[i] ---->" + fd0[i]);	
		}
	}
	
	Button std_button(Composite composite1, String s)
	{
		GridData gridData3 = new GridData();
		gridData3.heightHint = 50;
		
		Button browse_button = new Button(composite1, SWT.PUSH );	// BUTTON - NOT ADD OUTSIDE
		browse_button.setText(s);
		browse_button.setSize(200,100);
		browse_button.setLayoutData(gridData3);
		browse_button.pack();
		if ( debug )
		{
			System.out.print("BROWSE browse_button.getSize() " + browse_button.getSize() );
		}
		return browse_button;
	}
	
	String display_mixed_strings( Display display, String sstt[], StyledText page) //
	{
		int after, before;
		
		//Device d = Device.CurrentDevice;
		
		Device d = (Device ) display;			
		if (debug)
		{
			System.out.println("DISPLAY ---->" + d);
		}
		Shell sh = display.getActiveShell();		
		
		if ( debug )
		{
			System.out.println("SHELL ---->" + sh);
		}
		
		//Font f0 = sh.getFont();
		Shell sha[] = display.getShells();		
		
		if (debug )
		{	
			System.out.println("SHELL[0] ---->" + sha[0]);
		}
		
		// THE ORIGINAL FONT 
		Font f_old = sha[0].getFont();
		
		// THE ORIGINAL FONT INFORMATION
		FontData fd0[] = f_old.getFontData();		display_font_data(fd0);
		
		
		// BOLD FROM ORIGINAL
		FontData fd_new = fd0[0];
		fd_new.setStyle(SWT.BOLD);
		Font f_new = new Font(display, fd_new );
		
		
		
		// FONT (1) 
		
		/*
		 bold
		 underlined
		 SWT.BOLD SWT.ITALIC SWT.NORMAL
		 
		 page.setFont(
		 */
		String fontname = "Arial";
		fontname = "Arial";
		
		Font f1 = new Font(display, fontname, 24, SWT.BOLD);
		Font f2 = new Font(display, fontname, 24, SWT.ITALIC);
		/*		
		 page.setFont(f1);	page.append("font 1");
		 page.setFont(f2);	page.append("font 2");
		 page.setFont(f1);	page.append("font 1 again");
		 
		 remebers last font set!!!!
		 */
		
		String text_out3 = "";
		String line;
		String tag;
		int i;
		int count = 0;
		
		boolean bold_on = false;
		boolean underline_on = false;
		
		for(i=0;i<sstt.length;++i)
		{
			
			if ( ( i & 1 ) == 1 ) // tag
			{
				tag = sstt[i];
				if ( tag.length() >= 4 )
				{
					if ( tag.substring(0,4).equals( "<br " ) )
					{
						line = "\n";
						count = count + 1;
						page.append(line);
						text_out3 = text_out3 +  line;
					}
				}
				// f0 fb
				//System.out.println("+++++++++" + tag +  tag.matches("<span") +  tag.matches("bold") );
				////////////////////System.out.println("+++++++++" + tag +  ( tag.indexOf("<span") >= 0) +   (tag.indexOf("bold")  >= 0) );
				
				
				//if (i % 3 == 0)
				if ( ( tag.indexOf("<span") >= 0)  &&  (tag.indexOf("bold") >= 0))
				{
					bold_on = true;
					//f = fb;
					page.setFont(f_new);
				}
				else
				{
					bold_on = false;
					//f = f0;
					page.setFont(f_old);
				}
				if ( ( tag.indexOf("<span") >= 0)  &&  (tag.indexOf("underline") >= 0))
				{
					underline_on = true;
					//f = fb;
					page.setFont(f_new);
				}
				else
				{
					underline_on = false;
					//f = f0;
					page.setFont(f_old);
				}
				
			}
			else			// nontag
			{
				if (!sstt[i].equals(""))
				{
					
					line = sstt[i];						
					Text t = new Text(page, SWT.BORDER);
					t.setText(line);
					String line2 = line;
					before =  count;
					count = count + line2.length();
					after = count;
					page.append(line2);
					System.out.println(before + line2 + after + bold_on );
					{
						
						StyleRange styleRange = new StyleRange();
						
						if ( underline_on ) // underline simulated by reverse video
						{
							styleRange.foreground = page.getBackground();
							styleRange.background = page.getForeground();
						}
						
						if ( bold_on )
						{
							styleRange.fontStyle = SWT.BOLD;
						}
						styleRange.start = before;
						styleRange.length = after - before;
						if ( debug )
						{
							System.out.println("=========== " + before + " " + after);
						}
						page.setStyleRange(styleRange);
						
					}
					text_out3 = text_out3 + line;
				}
			}
		}
		
		
		if (debug )
		{
			System.out.println("5555555555");
			System.out.println(text_out3);
			System.out.println("66666666666");
		}
		
		return text_out3;
		
	}
	
	String display_html_file(Display display, String name, StyledText page) //
	{
		int i;
		String text_out;
		StringBuffer buffer = new StringBuffer();
		
		try
		{
			BufferedReader input = new BufferedReader(new FileReader(name));
			
			String text;
			
			while ( ( text = input.readLine() ) != null )
			{
				int start; 
				buffer.append(text + "\n");	
			}
		}
		catch (Exception e )
		{
			System.out.println("Caugh Excepion\n");
		}
		
		//text_out = remove_newlines( buffer.toString() );
		text_out = buffer.toString();
		
		String ss[] = text_out.split("<[^>]*>");
		String tt[] = extract_tags(text_out);
		
		String text_out2 = "";
		if (debug )
		{
			System.out.println("1111111");
		}
		for(i=0;i<ss.length;++i)					//  BETWEEN TAGS
		{
			if ( ss[i].equals("\n") )
			{
				ss[i] = "";
			}
			ss[i]=ss[i].replaceAll("\n"," ");
			
			System.out.println("...  |" + ss[i] + "|" + i + "/" + ss.length);
			if ( ! ss[i].equals("") )
			{
				//System.out.println(ss[i]);
				
			}
			text_out2 = text_out2  + "|" + ss[i] + "|\n";
			
		}
		if (debug )
		{
			System.out.println("2222222");
		}
		
		for(i=0;i<tt.length;++i)					//  TAGS
		{
			if ( debug )
			{
				System.out.println("..." +  i + "/" + tt.length);
			}
			tt[i]=tt[i].replaceAll("\n","");
			if (debug )
			{
				System.out.println(tt[i]);
			}
		}
		if ( debug )
		{
			System.out.println("333333333");
		}
		
		String sstt[] = new String[ ss.length + tt.length];
		for(i=0;i<sstt.length;++i)
		{
			
			if ( ( i & 1 ) == 1 ) // tag
			{
				sstt[i] = tt[i/2];
			}
			else
			{
				sstt[i] = ss[i/2];
			}
		}
		if ( debug )
		{
			System.out.println("444444444");
		}
		
		String text_out3 = display_mixed_strings( display, sstt,  page);
		
		return  text_out3; // text_out
	}
	/************************** MAIN *******************************************************************/
	public  Composite create_two_buttons( Composite shell, String s1, String s2)
	{
		
		Composite two_buttons = new Composite(shell, SWT.BORDER);
		two_buttons.setLayout(new FillLayout(SWT.HORIZONTAL));
		Button b1 = new Button(two_buttons,SWT.PUSH); b1.setText(s1);
		b1.setSize(100,100);
		Button b2 = new Button(two_buttons,SWT.PUSH); b2.setText(s2);
		b2.setSize(100,100);
		two_buttons.pack();
		return two_buttons;
	}
	
	public  void tree_area( Display display, Composite composite1 )
	{
		GridData gridData= new GridData();
		gridData.horizontalSpan = 1;
		gridData.verticalSpan = 7; // 7-> too big
		// 6 -> too big
		gridData.widthHint = 100;
		gridData.heightHint = 100;
		gridData.verticalAlignment = GridData.FILL;
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessVerticalSpace = true;
		gridData.grabExcessHorizontalSpace = true;
		Label l = new Label(composite1, SWT.NONE); 
		
		l.setText( "where am i" );
		l.setBackground(new Color(display,0,255,0) );
		l.setSize(50,700);
		l.setLayoutData(gridData);
	}
	
	private void dialogChanged()
	{
		//String s =  this.getText();
		//System.out.println("changes string is" + s);
		// updateStatus(null);
	}
	
	void ntn_hash_dump()
	{
		for(int j=0;j< local_ntn.steps.length; ++j)
		{
			if ( ! local_ntn.steps[j].apply_name.equals("") )
			{
				
				for(int k=0;k < local_ntn.steps[j].wqg.questions.length; ++k)
				{	
					Text t = local_ntn.steps[j].wqg.questions[k].input_area;
					if ( t != null )
					{
						if ( debug )
						{
							System.out.println("ZZZZZZ page = " + (j+1) + " question = " + (k+1) + " hashcode = " + t.hashCode() );
						}
					}
					else
					{
						if ( debug )
						{
							System.out.println("ZZZZZZ page = " + (j+1) + " question = " + (k+1) + " hashcode = " + "NO HASH CODE" );
						}
					}	
				}
			}
		}
	}
	
	Text get_text_area(String apply_page, String  question_prompt)
	{
		ntn_hash_dump();
		for(int j=0;j< local_ntn.steps.length; ++j)
		{
			if ( debug )
			{
				System.out.println("ZZZ got=|" + local_ntn.steps[j].apply_name +"|" + " want=|" + apply_page +"|" );
			}
			if (  local_ntn.steps[j].apply_name.equals(apply_page) )
			{
				
				for(int k=0;k < local_ntn.steps[j].wqg.questions.length; ++k)
				{	
					if ( debug )
					{
						System.out.println("ZZZZZZ got=|" + local_ntn.steps[j].wqg.questions[k].prompt+"|" + " want=|" + question_prompt +"|" );
					}
					if ( local_ntn.steps[j].wqg.questions[k].prompt.indexOf(question_prompt) >= 0 )
					{
						// look for Course title entry field
						// input_area is NULL!!!!!
						// System.out.println("Fri Mar 18 input area= " + local_ntn.steps[j].wqg.questions[k].input_area);
						// System.out.println("Fri Mar 18 input answer  " + wq.answer);
						Text t = local_ntn.steps[j].wqg.questions[k].input_area;
						
						if (debug )
						{
							System.out.println("ZZZZZZ " + "page = " + (j+1) + " question = " + (k+1)  + "t = " + t.hashCode());
						}
						
						return t;
					}
				}
			}
		}
		return ( Text ) null;
	}
	Text get_item_title_text_area()
	{
		return get_text_area("applyToItem","title");
	}
	Text get_hierarchy_title_text_area()
	{
		return get_text_area("applyToHeirarchy","title");
	}
	TreeItem get_tree_selection()
	{
		try
		{
			TreeItem[] ti = local_ntn.gui_tree.getSelection();
			return ti[0];
		}
		catch (Exception e)
		{
			return (TreeItem) null;
		}
	}	
	String get_tree_item_type(final TreeItem ti)
	{
		MyTreeItem mti = (MyTreeItem) ti;
		/////String type = ( (WckerTree)(mti.payload) ).type;
		
		WckerTree wt = (WckerTree) mti.payload ;
		String type = ((OrganisationPayLoad) wt.payload).type;
		return type;
		
	}
	
	void set_title_in_NTN(String title)
	{
		local_ntn.course_title = title;
		// also get top level of tree IN APPLICATION structure
		
		// SET IN NTN at one level
		WckerTree wt0 = local_ntn.organization;
		( ( OrganisationPayLoad ) wt0.payload).nodename = title;
		
		// SET IN NTN at second level
		WckerTree wt1 = local_ntn.organization.children[0];
		( ( OrganisationPayLoad ) wt1.payload).nodename = title;
	}
	public void question_to_composite(final WckerQuestion wq, Composite shell, boolean special_arg)
	{


		
		Label l = new Label(shell, SWT.NONE);		// PROMPT
		WckerTree structure_top = local_ntn.structure_terms.children[0];
		String top_level_type = ((StructurePayLoad)structure_top.payload).getName();

		l.setText
		( 
			wq.prompt.replaceAll("\\$LEVEL_TYPE\\$", top_level_type)
		);				// trampoline
		{
			GridData gridData= new GridData();	
			gridData.horizontalSpan =  ncols;
			l.setLayoutData(gridData);
			
		}
		wq.prompt_area = l;
		
		boolean special = ( wq.prompt.indexOf(" aim") >= 0) ;
		
		/**/
		Text t = new Text(shell, special ? SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL : SWT.BORDER );  // INPUT
		
		if (debug )	
		{
			System.out.println("XYZ CREATING QUESTION TEXT wixard page = " + wizard_page_number + "  hashcode = " + t.hashCode() );
		}

		wq.input_area = t;
		//Text t.setLayoutData(gridData);
		t.setText("Type something in here");
		
		t.addModifyListener				// text area 
		(
				new ModifyListener()
				{
					public  void modifyText(ModifyEvent e)
					{
						Text src = (Text) e.widget;
						
						if ( debug )
						{
							System.out.println("YYYY DATA is " + e.data + "widget = " +  src.getText());
							System.out.println("YYYY apply_name is " + local_ntn.steps[wizard_page_number-1].apply_name );
							System.out.println("YYYY prompt is |" +  wq.prompt + "|");
						}
						wq.answer = src.getText();
						if ( debug )
						{
							System.out.println("YYYY answer is |" +  wq.answer + "|");	
						
							System.out.println("----------------------------------------------------->");
							System.out.println(local_ntn);
							System.out.println("----------------------------------------------------->");
						}
						
						
						// HIERARCHY PAGE - want turning pacge back to work
						if ( local_ntn.steps[wizard_page_number-1].apply_name.equals("applyToHeirarchy") )		// BACKWARDS FLOW - WHILE editing test area on HIERARCHY page
						{
							if ( wq.prompt.indexOf("title") != -1 ) // YES TITLE -> so change tree contents		// check we are working on a TITLE field
							{	
								TreeItem ti = get_tree_selection();
								
								if ( ti != null ) // tree editing page						
								{
									ti.setText(wq.answer);						// SET TREE TEXT
{	
	WckerTree w = ( WckerTree) ( ((MyTreeItem) ti).payload );
	OrganisationPayLoad o = ( OrganisationPayLoad) w.payload ;
	o.nodename = new String(wq.answer);
									
}
									String type = get_tree_item_type(ti);
									if ( debug )
									{
										System.out.println("Fri Mar 18 type = " + type);
									}

									if ( type.equals("Course") )					// COURSE selected in tree
									{
										if ( wq.answer.equals(local_ntn.course_title) ) // have we set the title already
										{
											
										}
										else
										{
											set_title_in_NTN(wq.answer);						// SET NEED TO KNOW  (if course)
											
											Text t = get_item_title_text_area();	// this comes out as null!!!	
if ( debug )
{
											System.out.println("BACKWARDS XYZ Apply to hierachy title editing propagating " + wq.answer + " to " + t + " hashcode = " + t.hashCode() + " src hashcode = " + src.hashCode());
}
											if ( t != null )
											{	
												t.setText(wq.answer);						// SET ITEM AREA     (if course)
												System.out.println("YYYY Apply to hierachy title editing propagated " + wq.answer);
											}
											else
											{
												System.out.println("BACKWARDS YYYY null text widget");
											}
											
											
										}
									}
								}		
							}
						}
						else if  ( local_ntn.steps[wizard_page_number-1].apply_name.equals("applyToItem") )  // FORWARDS FLOW - ITEM page and COURSE
						{
							if ( wq.prompt.indexOf("title") != -1 )				// check we are working on a TITLE field
							{	
								if ( wq.answer.equals(local_ntn.course_title) )	 // no need to propagate
								{
								}
								else
								{
									/*
									 How do we get this to display?
									 We need to update the relevant tree item at the top level
									 */
									if ( debug )
									{
										System.out.println("YYYY filtching out top level tree item + gui_tree");
									}
									
									TreeItem top = get_tree_top(local_ntn.gui_tree);
									if ( top != null )
									{		
										top.setText(wq.answer);	
										set_title_in_NTN(wq.answer);						// --->  SET NEED TO KNOW  (if course)
										
										Text t = get_hierarchy_title_text_area();				// ---> SET HIERACHY AREA  (if course)
										if ( t != null )
										{	
											t.setText(wq.answer);						
										}
									}
									/**************************
									 TreeItem ti = get_tree_selection();
									 if ( ti != null ) // tree editing page						
									 {					
									 String type = get_tree_item_type(ti);
									if ( debug )
									{
										 System.out.println("Fri Mar 18 type = " + type);
									}
									 if ( type.equals("Course") )					// COURSE selected
									 {
									 ti.setText(wq.answer);							// --->  SET TREE TEXT     (if course)
									 set_title_in_NTN(wq.answer);						// --->  SET NEED TO KNOW  (if course)
									 
									 Text t = get_hierarchy_title_text_area();				// ---> SET HIERACHY AREA  (if course)
									 if ( t != null )
									 {	
									 t.setText(wq.answer);						
									 }
									 }
									 }	
									 ******************/		
								}
							} 
						}
						
						dialogChanged();
					}
				}
		);
		/**********/
		
		{
			GridData gridData= new GridData();	
			if ( special )
			{
				gridData.heightHint = 50;
				gridData.widthHint = 200;
				gridData.horizontalAlignment = GridData.FILL;
				
				gridData.grabExcessVerticalSpace = true;
				gridData.verticalAlignment = GridData.FILL;		
				
				//type = SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL ;
			}
			else
			{
				gridData.horizontalAlignment = GridData.FILL;
			}
			gridData.horizontalSpan =  ncols;
			t.setLayoutData(gridData);
			
			//t[i].setBounds(10,90,200,20);
			
		}
		
		
		
	}
	
	
	Composite previous_and_next(Composite shell)
	{
		
		Composite c = new Composite(shell, SWT.NONE);
		/*{
		 GridData gridData= new GridData();
		 gridData.horizontalSpan = 3;
		 c.setLayoutData(gridData);
		 }
		 */
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 3;
		c.setLayout(gridLayout);
		
		
		
		Label l = new Label(c, SWT.NONE);
		l.setText("");
		{
			GridData gridData= new GridData(GridData.FILL_HORIZONTAL);
			//gridData.grabExcessHorizontalSpace = true;
			//gridData.horizontalAlignment = GridData.FILL;
			//gridData.grabExcessVerticalSpace = true;
			//gridData.verticalAlignment = GridData.FILL;
			l.setLayoutData(gridData);
		}
		
		
		
		Button  button5 = new Button(c, SWT.PUSH); // BUTTON
		button5.setText("Previous Item");	
		button5.pack();
		{
			GridData gridData= new GridData();
			button5.setLayoutData(gridData);		
		}
		
		button5.addSelectionListener
		(
				new SelectionListener()
				{
					/*
					 if we hit "Next Item" we move to next tree
					 item in a depth first manner. If current item
					 is NOT expanded then we expand it
					 
					 */
					public void widgetSelected(SelectionEvent e) {
						if (debug )
						{
							System.out.println("Button 5 Selection Event");
						}
					}
					public void widgetDefaultSelected(SelectionEvent e) {
						if (debug )
						{
							System.out.println("Button 5 Default Selection Event");
						}
					}
					
				}
		);
		
		
		Button  button6 = new Button(c, SWT.PUSH); // BUTTON
		button6.setText("Next Item");
		button6.pack();
		{
			GridData gridData= new GridData();
			button6.setLayoutData(gridData);
			
		}
		button6.addSelectionListener
		(
				new SelectionListener()
				{
					public void widgetSelected(SelectionEvent e) {
						if ( debug )
						{
							System.out.println("Button 6 Selection Event");
						}
					}
					public void widgetDefaultSelected(SelectionEvent e) {
						if ( debug )
						{
							System.out.println("Button 6 Default Selection Event");
						}
					}
					
				}
		);
		two_buttons(button5,button6);
		//c.layout();
		return c;
	}
	/********/
	public Composite spacing_bar(Composite shell)
	{
		Composite c = new Composite(shell, SWT.NONE);
		
		Label l1 = new Label(c, SWT.NONE);
		l1.setText("");
		return c;
	}
	
	public Composite question_group_to_composite (int step, WckerQuestionGroup wqg, Composite shell)
	{
		Composite composite1;
		composite1 = new Composite(shell, SWT.NONE);
		WckerColour.Normalize(composite1);
		if ( do_grid )
		{
			GridLayout gridLayout = new GridLayout();
			gridLayout.numColumns = ncols;
			composite1.setLayout(gridLayout);
		}
		else
		{		
			composite1.setLayout(new FillLayout(SWT.VERTICAL)  );
		}
		
		//String s[] = { "Title:", "Author:",     "Course aim:" };
		
		int count = wqg.questions.length;	// no of questions in question group
		
		
		for(int i =0; i <count; ++i)
		{
			question_to_composite(wqg.questions[i], composite1,   i == 2 );
		}
		
		
		Composite b = spacing_bar( composite1 );
		
		{			
			GridData gridData= new GridData(GridData.FILL_VERTICAL);
			gridData.grabExcessVerticalSpace = true;
			gridData.verticalAlignment = GridData.FILL;
			gridData.horizontalSpan = ncols;
			b.setLayoutData(gridData);
		}
		
		////Composite c = previous_and_next(shell);
/*********************
		if ( local_ntn.steps[step-1].apply_name.equals("applyToHeirarchy") && ( ! sashform_status) )
		{
			Composite c = new PreviousNext(shell,SWT.NONE,local_ntn);
			local_ntn.pn = (PreviousNext) c;
		
			GridData gridData= new GridData(GridData.FILL_HORIZONTAL);
			gridData.horizontalSpan = ncols;
			c.setLayoutData(gridData);
		}
************************/	
		
		return composite1;
		
	}
	
	Composite step_to_composite(int step, Composite shell)
	{
		/*****
		 WckerQuestionGroup qg = local_ntn.step_to_question_group(3);
		 local_ntn.steps[step].wqg = qg;
		 return question_group_to_composite (qg, shell);
		 ****/
		
		return question_group_to_composite ( step, local_ntn.steps[step - 1].wqg , shell);
	}
	public  Composite tac(Composite shell,int pagenumber)
	{
		return step_to_composite(pagenumber, shell);
		
	}
	
	Composite lhs_and_rhs_with_buttons(Composite shell,NeedToKnow ntn_arg, int page_number) 
	{
		if ( sashform_status )
		{
			/**********
			Composite intermediate = new SashForm(shell,SWT.VERTICAL);
			lhs_and_rhs(intermediate, ntn_arg, page_number) ;
	

			Composite c = new PreviousNext(intermediate,SWT.NONE,local_ntn);
			local_ntn.pn = (PreviousNext) c;
		
			GridData gridData= new GridData(GridData.FILL_HORIZONTAL);
			gridData.horizontalSpan = ncols;
			c.setLayoutData(gridData);

			return intermediate;
			**********/
/******			
	Composite child3 = new Composite(shell,SWT.NONE);
	child3.setLayout(new FillLayout());
//	new Label(child3,SWT.PUSH).setText("Label in pane3");

	proc_within_form(child3);	// draw correctly aligned buttons as exemplar
	return shell;
*******/

/**********************/
	Composite child3 = new Composite(shell,SWT.NONE);
	child3.setLayout(new FillLayout(SWT.VERTICAL));
	proc_within_form(child3, ntn_arg,  page_number);	// draw correctly aligned buttons as exemplar
	return shell;
/***********************/
			/************

			Composite intermediate = new Composite(shell,SWT.NONE);
			intermediate.setBackground( new Color(Display.getDefault() ,0,255,0));
			intermediate.setLayout( new FillLayout() );		

			//lhs_and_rhs(intermediate, ntn_arg, page_number) ;
			new Label(intermediate,SWT.PUSH).setText("lhs_and_rhs lhs_and_rhs lhs_and_rhs");

			local_ntn.pn = new PreviousNext(intermediate,SWT.NONE,local_ntn);
			local_ntn.pn.setLayout(new FillLayout(GridData.HORIZONTAL_ALIGN_END));
			local_ntn.pn.setBackground( new Color(Display.getDefault() ,255,255,0));

			//new Label(intermediate,SWT.PUSH).setText("PreviousNext");
			
			Button b2 = new Button(intermediate,SWT.PUSH);
			GridData g2= new GridData( GridData.HORIZONTAL_ALIGN_END );
			b2.setLayoutData(g2);

			Composite c = new Composite(intermediate,SWT.BORDER);
			c.setSize(100,100);
			c.setLayoutData(g2);
			c.setBackground( new Color(Display.getDefault() ,255,255,0));
			return intermediate;
			*********/
		}
		else
		{
			return lhs_and_rhs(shell, ntn_arg, page_number) ;
		}
	}
	
	/**
	 * draws tree area and question group area
	 */

	Composite lhs_and_rhs(Composite shell,NeedToKnow ntn_arg, int page_number) 
	{
		
		Composite lhs_and_rhs;
		int count = 0;
		String decideratum = ntn_arg.steps[page_number-1].apply_name;
		String action = ntn_arg.steps[page_number-1].action;
		//System.out.println("ZZZZZZZZZ page = " + page_number + " decideratum=" +  decideratum + " action = " + action );

		if ( sashform_status )
		{
			// shell.setLayout( new FillLayout() ); // ireland
			SashForm form = new SashForm ( shell, SWT.HORIZONTAL | SWT.NULL);
			form.SASH_WIDTH = WckerSystem.getSashWidth();
			lhs_and_rhs = (Composite) form;
			lhs_and_rhs.setLayout( new FillLayout() );
		}
		else
		{
		
			lhs_and_rhs = new Composite(shell,SWT.BORDER);
			
		}

		if ( decideratum.equals("applyToHeirarchy") )
		{
			Composite lhs  = lhs(lhs_and_rhs);
			lhs.setLayoutData( BustingGridData. getValue() );
			count++;
		}

		Composite rhs  = tac(lhs_and_rhs,page_number);
		rhs.setLayoutData( BustingGridData. getValue() );
		GridData gridData= new GridData();
		count++;

		
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = count;
		lhs_and_rhs.setLayout(gridLayout);
		return lhs_and_rhs ;
	}
	void display_wcker_tree_REVISED( MyTreeItem composite0,  WckerTree wt) //####### REVISED
	{		
		MyTreeItem ti = display_leaf_REVISED(composite0,wt);
		for(int i =0; i < wt.children.length; ++i)
		{
			display_wcker_tree_REVISED( ti, wt.children[i] );
		}
	}
	void display_wcker_tree_REVISED( Tree composite0,  WckerTree wt)		//####### REVISED
	{		
		MyTreeItem ti = display_leaf_REVISED(composite0,wt);
		for(int i =0; i < wt.children.length; ++i)
		{
			display_wcker_tree_REVISED( ti, wt.children[i] );
		}
	}
	/**
	 * Creates a new content package in a working directory
	 *
	 */
	public static ContentPackage build_cp(NeedToKnow ntk, File targetFolder) {
		if ( debug ) {
			System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			System.out.println("Building Content Package in " + targetFolder);
		}
		
		ContentPackage cp = null;
		CP_EditorHandler cpEH = new CP_EditorHandler();
		Namespace cpNS = Namespace.getNamespace("http://www.imsproject.org/xsd/imscp_rootv1p1p2");
		//cpFolder - A folder to put the manifest and other files into.
		File cpFolder = targetFolder;
		WckerTree org = ntk.organization; 
		
		try {
			//TODO: derive which standards we're working with from the Wizard's .wsi file
			//cpController - a pointer to a particuar version of IMS Content Packaging, and Reload mechanisms to handle it
			CP_SchemaController cpController = new CP112_SchemaController();
			System.out.println(cpController);
			
			//mdController - a pointer to a particuar version of IMS Metadata, and Reload mechanisms to handle it
			MD_SchemaController mdController = new MD121_SchemaController();
			System.out.println(mdController);
			
			// The ContentPackage class is where the action happens, with
			// Reload creating a CP manifest file and in-memory representation.
			// Make a content package:
			cp = new ContentPackage(cpFolder, cpController, mdController);
			// We should now have a CP with an 'organizations' element, but nothing inside it.
			
			
			// Add the NeedToKnow hierarchy as a IMSCP organization
			for(int i = 0; i < org.children.length; ++i) {
				String childName = ( (OrganisationPayLoad) org.children[i].payload).getName();
				
				// Create a new child 'organization' element
				XMLPath childXmlPath = new XMLPath("manifest/organizations/organization");
				SchemaElement newChildElement = (SchemaElement)cp.getSchemaController().getSchemaNode(childXmlPath);
				
				// The target 'organizations' element 
				Element cpRoot = cp.getRootElement(); 
				Element parentElement = cpRoot.getChild("organizations", cpNS);
				
				// Add the 'organization' element to the target 'organizations' element
				cp.addElementBySchema(cp, parentElement, newChildElement, false);
				
				// Identify the newly added 'organization' node.
				java.util.List childList = parentElement.getChildren();
				Element thisElement = (Element)childList.get(i);
				
				// Set the 'organization' title from the NTK
				Element thisTitle = thisElement.getChild("title", cpNS);
				thisTitle.setText(childName);
				
				//Recurse down the child nodes.
				build_cp_org_tree(cp, thisElement, org.children[i]);
			}
			
			//Save our progress
			cp.saveDocument();
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			System.out.println("Couldn't create new CP_EditorHandler");
			e.printStackTrace();
		} 
		
		//Return the content package
		return cp;
	}
	
	/*
	 * Build manifest organization from NTK object, from any Element
	 */
	private static void build_cp_org_tree(ContentPackage cp, Element parentElement, WckerTree org) {
		// Iterate over nodes in the WckerTree and add an item to the ContentPackage organisation.
		// For each node, 
		if (debug) {
			System.out.println("--------- Build tree iterator ----------");
		}
		Namespace cpNS = Namespace.getNamespace("http://www.imsproject.org/xsd/imscp_rootv1p1p2");
		
		for(int i = 0; i < org.children.length; ++i) {
			String childName = ( (OrganisationPayLoad) org.children[i].payload ).getName();
			// Construct a new 'item' SchemaElement
			XMLPath childXmlPath = new XMLPath("manifest/organizations/organization/item");
			SchemaElement newChildElement = (SchemaElement)cp.getSchemaController().getSchemaNode(childXmlPath);
			
			// Set the 'item' details from the NTK
			//TODO: Set the 'item' details
			if (debug) {
				System.out.println("This child: " + childName);
			}
			
			// Add the SchemaElement to the CP
			cp.addElementBySchema(cp, parentElement, newChildElement, false);
			
			// Identify the newly added child node.
			java.util.List childList = parentElement.getChildren("item", cpNS);
			Element thisElement = (Element)childList.get(i);
			
			// Set the 'organization' title from the NTK
			Element thisTitle = thisElement.getChild("title", cpNS);
			thisTitle.setText(childName);
			
			//Recurse down the child nodes.
			build_cp_org_tree(cp, thisElement, org.children[i]);
		}
	}
	
	
	static Composite exportSkeletonComposite(Composite parent, NeedToKnow ntn) {
		final NeedToKnow thisNtn = ntn; 
		Composite wrapper = new Composite(parent, SWT.BORDER);
		wrapper.setLayout(new GridLayout());
		WckerColour.Normalize(wrapper);
		
		/* Add the main content */
		String title = "Export course skeleton"; //TODO: Should get title dynamically 
		Label wrapperLabel = new Label(wrapper, SWT.NONE);
		wrapperLabel.setText(title);
		wrapperLabel.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_BEGINNING));
		//Create the Exporter (containing the export list)
		//TODO: Only allow this when the wizardPage is viewed
		final SkeletonExporter se = new SkeletonExporter(thisNtn);
		
		/* Composite version
		 //Create an area to display the export list
		  Composite exportReport = new Composite(wrapper, SWT.V_SCROLL|SWT.BORDER);
		  exportReport.setLayout(new GridLayout());
		  exportReport.setLayoutData(new GridData(GridData.FILL_BOTH));
		  // Add the ExportList contents to the composite
		   for(int i=0; i<se.size(); i++) {
		   ExportListEntry thisEntry = (ExportListEntry)se.get(i);
		   Label thisLabel = new Label(exportReport, SWT.NONE);
		   thisLabel.setText(thisEntry.getItem());
		   if(debug) {
		   System.out.println("thisLabel: " + thisLabel);
		   }
		   }
		   */
		
		//List version
		//Create an area to display the export list
		final List exportReport = new List(wrapper, SWT.V_SCROLL|SWT.BORDER);
		//exportReport.setLayout(new GridLayout());
		exportReport.setLayoutData(new GridData(GridData.FILL_BOTH));

		//Add the ExportList button
		Button exportListButton = new Button(wrapper, SWT.PUSH);
		exportListButton.setText("Prepare export");
		GridData exportListGD = new GridData(GridData. HORIZONTAL_ALIGN_END );
		exportListButton.setLayoutData(exportListGD);
		
		//Add the Export button
		final Button exportButton = new Button(wrapper, SWT.PUSH);
		exportButton.setText("Export");
		GridData gd = new GridData(GridData. HORIZONTAL_ALIGN_END );
		exportButton.setLayoutData(gd);
		exportButton.setEnabled(false);
		

		//Add the ExportList button listener
		exportListButton.addSelectionListener ( 
				new SelectionListener()
				{
					public void widgetSelected(SelectionEvent e) {
						// Add the ExportList contents to the composite
						for(int i=0; i<se.size(); i++) {
							ExportListEntry thisEntry = (ExportListEntry)se.get(i);
							exportReport.add(thisEntry.getExportDesc());
						}
						exportButton.setEnabled(true);
					}
					public void widgetDefaultSelected(SelectionEvent e) {
						if (debug )
						{
							System.out.println("Default Selection Event");		
						}
					}
				}
		);

		//Add the Export button listener
		exportButton.addSelectionListener ( 
				new SelectionListener()
				{
					public void widgetSelected(SelectionEvent e) {
						try {
							se.export();
						} catch (IOException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
					}
					public void widgetDefaultSelected(SelectionEvent e) {
						if (debug )
						{
							System.out.println("Default Selection Event");
						}
					}
				}
		);
		
		return wrapper;
	}
	
	Composite forest(Composite composite0, NeedToKnow ntn, int style )
	{
		//Composite Wrapper = new Composite(composite0, SWT.BORDER);
		Composite Forest = new Composite(composite0, style);
		
		
		//WckerTree wt = ntn.organization;
		WckerTree wt = ntn.organization.children[0];
		int n_trees = wt.children.length;
		int n_cols  = (int) Math.sqrt(n_trees);
		if ( n_cols * n_cols != n_trees )
		{
			n_cols++;
		}
		
		//System.out.println("ZZZZZ forest n_cols = "+ n_cols + " n_trees = "+ n_trees);
		//System.out.println(ntn);
		
		Tree[] t = new Tree[n_trees];
		
		for(int i =0; i < n_trees; ++i)
		{
			//WckerTree w = ntn.organization; // too high level
			WckerTree w = wt.children[i] ;
			t[i] = tree_stuff_form_tree(Forest, w );
			expand_tree(t[i]);
			
			GridData gd = new GridData(GridData.VERTICAL_ALIGN_BEGINNING) ;
			t[i].setLayoutData(gd);
			
		}
		
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = n_cols;
		Forest.setLayout(gridLayout);
		Forest.setBackground(WckerColour.TreeBackgroundColour);
		Forest.setForeground(WckerColour.TreeForegroundColour);
		//icon_menu(composite0);
		
		/*****
		 Button  b = new Button(Wrapper, SWT.PUSH);
		 b.setText("Export");
		 GridData gd = new GridData(GridData. HORIZONTAL_ALIGN_END );
		 b.setLayoutData(gd);
		 
		 Wrapper.setLayout( new GridLayout() );
		 
		 return Wrapper;
		 ******/
		return Forest;
		
	}
	MyTreeItem display_leaf_REVISED(Tree t, WckerTree wt )   //######### REVISED
	{
		MyTreeItem item = new MyTreeItem(t, wt, SWT.NONE);
		String nodename = ( (OrganisationPayLoad) wt.payload ).nodename;

		item.setText(nodename);
		item.setImage( WckerIcon.wcker_tree_to_image( local_ntn, wt ));
		return item;
	}
	MyTreeItem display_leaf_REVISED(MyTreeItem t, WckerTree wt ) //######### REVISED
	{
		MyTreeItem item = new MyTreeItem(t, wt, SWT.NONE);
		String nodename = ( (OrganisationPayLoad) wt.payload ).nodename;
		item.setText(nodename);
		item.setImage( WckerIcon.wcker_tree_to_image( local_ntn, wt ));
		return item;
	}
	Tree tree_stuff_form_tree(Composite composite0, WckerTree wt )
	{
		boolean modern = true;
		
		Tree tree = new Tree(composite0, SWT.NONE);
		if ( modern )
		{
			display_wcker_tree_REVISED( tree,  wt );
		}
		else
		{
			//////display_wcker_tree( tree,  wt );
		}
		return tree;
	}
	static void expand_tree(Tree tree)
	{
		TreeItem[] tis = tree.getItems();
		for(int i = 0; i < tis.length; ++i)
		{
			tis[i].setExpanded(true);
		}
	}
	static void update_title_from_tree_item(NeedToKnow local_ntn, TreeItem ti)
	{
		int page_number = local_ntn.stage - 1;

		/////////////////page_number = wizard_page_number;
		if ( debug )
		{
			System.out.println("ZZZ  local_ntn.stage = " + local_ntn.stage + " page_number = " + page_number);
		}


		WckerQuestion Q[] = local_ntn.steps[page_number-1].wqg.questions;
		for(int i=0;i<Q.length;++i)
		{
			//System.out.println(i + ") " + Q[i].prompt);
			if ( Q[i].prompt.indexOf("title") >= 0 )
			{


	

String show_me = ti.getText();
if (debug )
{
	System.out.println("show_me = " + show_me);
}
				Q[i].input_area.setText(show_me);
			}
				
			/************new code start *************/
			 WckerTree wt =  (WckerTree)  ((MyTreeItem) ti).payload;
	 		String level_type =  ((OrganisationPayLoad) wt.payload).getType();

			Q[i].prompt_area.setText
			(  
				Q[i].prompt.replaceAll("\\$LEVEL_TYPE\\$", level_type) 
			);
			/***********new code stop **************/
		}
	}
	TreeItem get_tree_top(Tree tree)
	{
		TreeItem[] tis = tree.getItems();
		if (  tis.length > 0 )
		{
			return tis[0];
		}
		else
		{
			return null;
		}
	}
	void select_tree_top(Tree tree)
	{
		TreeItem ti = get_tree_top(tree);
		
		if ( ti != null )
		{
			local_ntn.select_and_see(  ti);
			/***
			TreeItem[] tis = { ti };
			tree.setSelection(tis);
			tree.showSelection();
			****/
		}
	}
void tell_me_about( TreeItem ti )
{
	NodeInfo ni = new NodeInfo(local_ntn, (MyTreeItem) ti);
	System.out.println( " tell_me_about --------------------" +   ti.getText()  );
	System.out.println( " tell_me_about ------------" + ni.label() );
	System.out.println( " tell_me_about ------------"  + WckerUtility.string_list_to_path(ni.label_path()) );
	System.out.println( " tell_me_about ------------"  +  ni.type() );
	WckerTree wt = (WckerTree) ( (MyTreeItem) ti).payload;
	
	NodeInfo ni2 = new NodeInfo(local_ntn, wt);
	System.out.println( " tell_me_about2 ------------"  );
	System.out.println( " tell_me_about2 ------------" + ni2.label() );
	System.out.println( " tell_me_about2 ------------"  + WckerUtility.string_list_to_path(ni2.label_path()) );
	System.out.println( " tell_me_about2 ------------"  +  ni2.type() );
}

	Tree tree_stuff(Composite composite0, final NeedToKnow ntn )
	{
		WckerTree wt = ntn.organization.children[0];
		local_ntn.gui_tree = tree_stuff_form_tree(composite0, wt  );
		final TreeButtons tbs = new TreeButtons(wizard_page_number,local_ntn,composite0);
		local_ntn.tbs = tbs;
		
		local_ntn.gui_tree.addSelectionListener
		(
				new SelectionListener() // Tree listener
				{
					public void widgetSelected(SelectionEvent e)  /// a tree item selected
					{

						if ( debug )
						{
							tell_me_about( (TreeItem) e.item );
						}
						update_title_from_tree_item( local_ntn, (TreeItem) e.item );
						tbs.update_6_buttons(local_ntn, (TreeItem) e.item );			
						
						//String ref = ntn.steps[wizard_page_number-1].questionGroup_ref;
						//System.out.println(s + " Selection Event" + "stage = " + wizard_page_number + " " + ref);
						//System.out.println(ntn);
						
					}
					public void widgetDefaultSelected(SelectionEvent e) 
					{
						if (debug )
						{
							System.out.println("Default Selection Event");
						}
					}
				}
		);
		local_ntn.gui_tree.addTreeListener
		(
				new TreeListener() // Tree listener
				{
					public void treeCollapsed(TreeEvent e)  /// a tree item selected
					{
						TreeItem[] ti = local_ntn.gui_tree.getSelection();
						if ( ti.length > 0 )
						{
							update_title_from_tree_item( local_ntn,  ti[0] );
							tbs.update_6_buttons(local_ntn, ti[0]);
							local_ntn.select_and_see( ti[0]);
						}
						else
						{
							tbs.disable_all();
							local_ntn.pn.disable_all();
						}
						/****
						if ( true )
						{
							tell_me_about( (TreeItem) e.item );
						}
						
						****/
					}
					public void treeExpanded(TreeEvent e)  /// a tree item selected
					{
						TreeItem[] ti = local_ntn.gui_tree.getSelection();
						if ( ti.length > 0 )
						{
							update_title_from_tree_item( local_ntn,  ti[0] );
							tbs.update_6_buttons(local_ntn, ti[0]);
							local_ntn.select_and_see( ti[0]);
						}
						else
						{
							tbs.disable_all();
							local_ntn.pn.disable_all();
						}

						/*****
						if ( true )
						{
							tell_me_about( (TreeItem) e.item );
						}
						update_title_from_tree_item( local_ntn, (TreeItem) e.item );
						tbs.update_6_buttons(local_ntn, (TreeItem) e.item );
						******/
					}
					
				}
		);
		
		expand_tree(local_ntn.gui_tree);
		////////////////////////////icon_menu(composite0); // Garsington
		return local_ntn.gui_tree;
		
	}
	
	Composite lhs(Composite shell) //(Shell shell)
	{
		Composite composite0 = new Composite(shell,SWT.NONE);
		//does this work????
		WckerColour.Normalize(composite0);
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 1;
		composite0.setLayout(gridLayout);
		
		//composite0.setLayout ( new FillLayout(SWT.VERTICAL));
		
		Label l   = new Label(composite0, SWT.NONE);
		l.setText("Course Structure");
		
		
		//Text tree = new Text(composite0, SWT.NONE);
		
		Tree tree = tree_stuff(composite0, local_ntn);
		tree.pack();
		tree.setSize(400,400);
		select_tree_top(tree);
		

		GridData gridData= new GridData();
		
		gridData.grabExcessVerticalSpace = true;
		gridData.grabExcessHorizontalSpace = true;
		gridData.verticalAlignment = GridData.FILL;		
		gridData.horizontalAlignment = GridData.FILL;	
		
		local_ntn.gui_tree.setLayoutData(gridData);
		
		//tree.setSize(200,600);
		
		
		return composite0;
		
	}
	
	WckerBrowser progress(Composite shell, NeedToKnow ntn_arg, int page_number)
	{
if ( sashform_status )
{
		Composite surround = new Composite(shell,SWT.NONE);
		surround.setSize(200,600);
		surround.setLayout(new FillLayout());

		String contents = local_ntn.toHTML(page_number);
		WckerBrowser progress_browser = new WckerBrowser(surround, SWT.BORDER);
		progress_browser.setText(contents);
/***
		GridData progress_GridData = new  GridData();
		progress_GridData.verticalAlignment=GridData.FILL;
		progress_GridData.grabExcessVerticalSpace = true;
		progress_GridData.widthHint=200;
		progress_browser.setLayoutData(progress_GridData);
***/
		return progress_browser; 

}
else
{
		String contents = local_ntn.toHTML(page_number);
		WckerBrowser progress_browser = new WckerBrowser(shell, SWT.BORDER);
		progress_browser.setText(contents);
		GridData progress_GridData = new  GridData();
		progress_GridData.verticalAlignment=GridData.FILL;
		progress_GridData.grabExcessVerticalSpace = true;
		progress_GridData.widthHint=200;
		progress_browser.setLayoutData(progress_GridData);
		return progress_browser; 
}
	}
	
	static String tart_ascii(String s)
	{
		
		String t = s.replaceAll("\n","<br>\n");
		String[] a = t.split("\n");
		String content = NeedToKnow.BOLD(a[0]);
	    String markup ="";
		for(int i = 1; i < a.length;++i)
		{	
			content += a[i];
		}
		markup +="<div style=\"font-family:verdana,sans-serif;font-size:0.8em;\">";
		markup +=content;
		markup +="</div>";
		return markup;
	}
	
	
	Composite page_one(Composite shell, NeedToKnow ntn_arg, int page_number)
	{
		// Load up the Wizard Schema Instance (.wsi) file
		local_ntn =  ntn_arg;
		
		////////////local_ntn.stage = page_number;
		
		
		// TODO: This window title text should be set to the name of the wizard + " - WCKER"
		
		GridLayout two = new GridLayout();
		two.numColumns = 2;
		shell.setLayout(two);
		
		
		//  row 1 columns 1
		WckerBrowser c1 = progress(shell , ntn_arg,  page_number);
		
		//  row 1 columns 2
		
		
		//Composite composite2 = lhs_and_rhs(shell,ntn_arg,page_number);
		//composite2.setLayoutData( BustingGridData.getValue() );
		
		
		//  row 1 columns 3
		
		Composite help_composite = new Composite(shell, SWT.BORDER);
		
		
		String text = tart_ascii(ntn_arg.steps[page_number-1].plaintext);
		Help h2 = new Help(help_composite, text );
		help_composite.setSize(200,600);
		return shell;
	}
public static SashForm snippet(Composite shell) {
	//final Display display = new Display ();
	//Shell shell = new Shell(display);
	shell.setLayout (new FillLayout());

	SashForm form = new SashForm(shell,SWT.HORIZONTAL);	// form inside shell
	form.setLayout(new FillLayout());
	
	Composite child1 = new Composite(form,SWT.NONE);
	child1.setLayout(new FillLayout());
	new Label(child1,SWT.NONE).setText("Label in pane 1");	// child1 inside  form 
	
	Composite child2 = new Composite(form,SWT.NONE);
	child2.setLayout(new FillLayout());
	new Button(child2,SWT.PUSH).setText("Button in pane2");

	Composite child3 = new Composite(form,SWT.NONE);
	child3.setLayout(new FillLayout());
	new Label(child3,SWT.PUSH).setText("Label in pane3");
	
	form.setWeights(new int[] {30,40,30});
	return form;

	
}
 void proc_within_form(Composite c,NeedToKnow ntn_arg, int page_number)
{
	GridLayout gridLayout = new GridLayout();
	gridLayout.numColumns = 1;
	
	c.setLayout(gridLayout);
/*
	Composite c2 = new Composite(c,SWT.BORDER);
	c2.setLayout(new FillLayout(SWT.VERTICAL));
	c2.setSize(800,800);
*/

//Composite c2 = c;


	
	//Button b1 = new Button(c2,SWT.PUSH); b1.setSize(20,20);
	//Button b2 = new Button(c2,SWT.PUSH); b2.setSize(20,20);
				GridData g1= new GridData( GridData.FILL_HORIZONTAL);

	//b1.setText("A2");	b1.setLayoutData(g1);

				GridData g2= new GridData( GridData.HORIZONTAL_ALIGN_END );

	//b2.setText("B2");	b2.setLayoutData(g2);
	
				GridData g3= new GridData( GridData.HORIZONTAL_ALIGN_END );
			//local_ntn.pn.setLayoutData(g3);

			Composite lhs_and_rhs = lhs_and_rhs(c, ntn_arg, page_number) ;
			lhs_and_rhs.setLayoutData(BustingGridData.getValue());

			if ( local_ntn.steps[page_number-1].apply_name.equals("applyToHeirarchy") )
			{
				local_ntn.pn = new PreviousNext(c,SWT.NONE,local_ntn); // the genuine call
				local_ntn.pn.setLayoutData( new GridData( GridData.HORIZONTAL_ALIGN_END  ));
			}

}
/*
				gridData.horizontalAlignment  = GridData.HORIZONTAL_ALIGN_END ;
				//gridData.grabExcessHorizontalSpace = true;     // nuevo
				gridData.horizontalAlignment = GridData.HORIZONTAL_ALIGN_FILL;  // nuevo
				//gridData.grabExcessVerticalSpace = true;
				//gridData.verticalAlignment = GridData.FILL;
*/

public void on_form(SashForm form)
{
	Composite child1 = new Composite(form,SWT.NONE);
	child1.setLayout(new FillLayout());
	new Label(child1,SWT.NONE).setText("Label in pane 1");	// child1 inside  form 
	
	Composite child2 = new Composite(form,SWT.NONE);
	child2.setLayout(new FillLayout());
	new Button(child2,SWT.PUSH).setText("Button in pane2");

	Composite child3 = new Composite(form,SWT.NONE);
	child3.setLayout(new FillLayout());
//	new Label(child3,SWT.PUSH).setText("Label in pane3");

	//proc_within_form(child3);
	
}

	Composite page_three_wrapper(Composite shell, NeedToKnow ntn_arg, int page_number)
	{
		SashForm form;

		if ( sashform_status )
		{
			boolean use_snippet = false;

			if ( use_snippet)
			{
				 form = snippet(shell);
			}
			else
			{
				

				GridLayout gridLayout = new GridLayout(); 			// complex
				gridLayout.numColumns = 1;					// complex
				shell.setLayout(gridLayout);	
				// complex

				// THESE BUTTONS WORK ON FULL WIDTH OF WINDOW - so shell must be window
/***
				Button b1 = new Button(shell,SWT.PUSH);
				Button b2 = new Button(shell,SWT.PUSH);
				b1.setText("A"); GridData g1= new GridData( GridData.FILL_HORIZONTAL);	b1.setLayoutData(g1);
				b2.setText("B"); GridData g2= new GridData( GridData.HORIZONTAL_ALIGN_END ); b2.setLayoutData(g2);
***/


				// ADD SASH FORM ACROSS WINDOW

				form = new SashForm(shell,SWT.HORIZONTAL);
				form.setLayout(new FillLayout());
				form.setLayoutData(BustingGridData.getValue());			// complex
				form.SASH_WIDTH = WckerSystem.getSashWidth();

				boolean traditional = false;

				if ( traditional )
				{
					on_form(form);
					form.setWeights(new int[] {30,40,30});
					
				}
				else
				{
					Composite c = page_three( form, ntn_arg,  page_number);		
				}

			}
			return shell;	
		}
		else
		{
			Composite c = page_three( shell, ntn_arg,  page_number);
			return shell;	
		}
	}
	Composite test_content(Composite shell, int count)
	{
		int i = 1;
		Composite c111 = new Composite(shell, SWT.NONE);
		c111.setLayout(new FillLayout());
		Label l = new Label(c111,SWT.PUSH);
		l.setSize(100,100);
		l.setText("test content " + count);
		
		i++;

		return c111;
		
	}
	Composite page_three(Composite shell, NeedToKnow ntn_arg, int page_number)
	{
		int count = 0;
		// Load up the Wizard Schema Instance (.wsi) file
		local_ntn =  ntn_arg;
		
		/**************  row 1 columns 1 - ALWAYS HAVE PROGRESS ******/
		if ( false /*sashform_status*/ )
		{
			Composite c111 =  test_content(shell,count + 1);
		}
		else
		{
			WckerBrowser c1 = progress(shell , ntn_arg,  page_number);
		}
		
		count++;
		//  row 1 columns 2
		
		//if ( ! (ntn_arg.steps[page_number-1].plaintext.equals("") || ! ntn_arg.steps[page_number-1].plaintext.equals("")) )
		if ( ! (ntn_arg.steps[page_number-1].plaintext.equals("") ))
		{
			/******** PLAINTEXT *****************/
			if (  false /*sashform_status*/ )
			{
				Composite c111 = test_content(shell,count + 1);
			}
			else
			{
				WckerBrowser help_browser = new WckerBrowser(shell, SWT.BORDER);
				String text = tart_ascii(ntn_arg.steps[page_number-1].plaintext);
				help_browser.setText(text);
				GridData help_GridData = new  GridData();
				help_GridData.verticalAlignment=GridData.FILL;
				help_GridData.widthHint=600;
				help_browser.setLayoutData(help_GridData);
			}
			count++;
		}
		else
		{
			if ( false /*sashform_status*/  )
			{
				Composite c111 =  test_content(shell,count + 1);
				count++;
			}
			else
			{
				String action = ntn_arg.steps[page_number-1].action;
				/*** STANDARD ******/
				if ( 	 action.equals("") )
				{
					Composite composite2 = lhs_and_rhs_with_buttons(shell, ntn_arg,  page_number);
					composite2.setLayoutData( BustingGridData.getValue() );
					count++;
				}	
				else if ( action.equals("exportSkeleton") )
				{
					Composite c = exportSkeletonComposite(shell, ntn_arg);
					c.setLayoutData(BustingGridData.getValue());
					count++;	
				}
				else if ( action.equals("importSkeleton") )
				{
					Composite c = importSkeleton.createComposite(shell, ntn_arg);
					count++;
				}
				else if ( action.equals( "exportPackage") )
				{
					Composite c = exportPackage.createComposite(shell, ntn_arg);
					count++;
				}
			}
			
			//  row 1 columns 3
			
		}
		
		
		/**************   HELP if plaintext is not there ******/
		boolean  help_present  =  ntn_arg.steps[page_number-1].plaintext.equals("");
		if ( help_present )
		{
			if ( false /*sashform_status*/ )
			{
				Composite c111 =  test_content(shell,count + 1);
			}
			else
			{
				WckerBrowser help_browser = new WckerBrowser(shell, SWT.BORDER);				
				GridData help_GridData = new  GridData();
				help_GridData.verticalAlignment=GridData.FILL;
				help_GridData.horizontalAlignment=GridData.FILL;
				help_GridData.widthHint=200;
				help_browser.setText(local_ntn.to_HTML_help(page_number));
				help_browser.setLayoutData(help_GridData);
			}
			count++;	
		}
		
		
		if ( ! sashform_status )
		{
			GridLayout two = new GridLayout();
			two.numColumns = count;
			shell.setLayout(two);
		}
		else
		{
			SashForm form = (SashForm) shell;
			
			int widths[] = new int[count];
			int progress_width = 20;
			int help_width = 20;
			int count_missing;
			int width_missing;


			widths[0] = progress_width;
			if ( help_present )
			{
				count_missing = 2;
				width_missing = progress_width + help_width ;
				widths[count-1] = help_width;
				
			}
			else
			{
				count_missing = 1;
				width_missing = progress_width;
			}
			for(int i= 1 ; i < ( (count - count_missing) + 1);++i)
			{
				widths[i] = ( 100 - width_missing ) / ( count - count_missing);
			}
			form.setWeights(widths);
			
		}
		
		return shell;
	}
	
	/*
	 * sets off a particular wizard using the given display
	 * @param wizardPackage name of wizard file
	 * @param display_arg display in which to set off the wizard
	 */
	public Wizard( Composite shell, NeedToKnow ntn_arg, int page_number ) 
	{
		wizard_page_number = page_number;
		ntn_arg.stage = page_number;
		sashform_status = false ;// System.getProperty("sashframe.status").equals("on");
		page_three_wrapper(shell, ntn_arg, page_number);
		
		shell.pack();
	}
}

