import java.lang.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;

 class MyPanelRenderer extends JLabel implements ListCellRenderer {
     final static ImageIcon longIcon = new ImageIcon("long.gif");
     final static ImageIcon shortIcon = new ImageIcon("short.gif");
   private final Color light_grey =  new Color(196,196,196);
   private final Color white =  new Color(255,255,255);
   private final Color orange =  new Color(255,128,0);
   private Color light_blue =  new Color(128,196,255);
    private final Font fb = new Font("Helvetica", Font.BOLD, 14);
   private final Font fn = new Font("Helvetica", Font.PLAIN, 12);
	Dimension acc = new Dimension(0,0);

     // This is the only method defined by ListCellRenderer.
     // We just reconfigure the JLabel each time we're called.
   private Container test_pad0(String s1, String s2, boolean isSelected)
   {
	JPanel p = new JPanel();
//	JPanel i = new JPanel();
	JPanel orange_square = new JPanel();
	orange_square.setForeground(orange);
	orange_square.setBackground(orange);

	Box v =  Box.createVerticalBox();
	Box v2 =  Box.createVerticalBox();
	Box h =  Box.createHorizontalBox();
	JLabel l1 = new JLabel(s1);
	JLabel l2 = new JLabel("T");
	JLabel l3 = new JLabel(s2);
	l1.setFont(fb);
	l2.setFont(fn);
	l3.setFont(fn);

	// THREE TEXT LINES
	v.add(l1);
	v.add(Box.createVerticalStrut(l2.getPreferredSize().height / 2));
	v.add(l3);

	Dimension rv2 = v.getPreferredSize();
	//int d =  rv2.height;
//System.out.println("SQUARE WIDTH " + rv2.height);

	orange_square.add(Box.createRigidArea( new Dimension(rv2.height, rv2.height)));

	orange_square.setSize(new Dimension(rv2.height, rv2.height));

	// ORANGE BOX; GAP ; THREE LINES; GLUE; |
	h.add(Box.createHorizontalStrut(l2.getPreferredSize().width));
	h.add( orange_square );
	h.add(Box.createHorizontalStrut(l2.getPreferredSize().width));
	h.add( v );
	h.add(Box.createHorizontalGlue());
	//h.add( new JLabel("|")  );

	v2.add( Box.createVerticalStrut(l2.getPreferredSize().height / 2 ));
	v2.add( h );
	v2.add( Box.createVerticalStrut(l2.getPreferredSize().height / 2 ));

	Dimension d = v2.getPreferredSize();
	 if (  d.width > acc.width )   acc.width = d.width;
	 if (  d.height > acc.height ) acc.height = d.height;
//System.out.println("cell width = " + d.width + " cell height = " + d.height);
//System.out.println("acc width = " + acc.width + "cell height = " + acc.height);

	//p.add(new JLabel("start"));
///////////////////
	GridBagConstraints constraints   =  new GridBagConstraints();
	GridBagLayout          layout 	=  new GridBagLayout();
	constraints.weightx = 0;
	constraints.weighty = 0;

	constraints.gridx = 0;
	constraints.gridy = 0;
	constraints.gridwidth = 1;
	constraints.gridheight = 1;
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.WEST;
	layout.setConstraints(p, constraints);
	p.setLayout( layout );				//1
///////////////////	
constraints.gridy = -1;

//	constraints.gridy++;
//	p.add(new JLabel("a") );

	constraints.gridy++;
	p.add(v2);

//	constraints.gridy++;
//	p.add(new JLabel("2") );
/****************************/
	 Box h2 = Box.createHorizontalBox();
	 //h2.add(new JLabel("a")); 
	 int difference = acc.width - d.width;
//	 difference = 20; 
//         System.out.println("difference = " + difference);

	 h2.add( Box.createHorizontalStrut(difference));
 	 ///h2.add(new JLabel("b")); 


	constraints.gridy++;
	p.add(h2);

/****************************/
//	constraints.gridy++;
//	p.add(new JLabel("4") );

	p.setForeground(isSelected ? light_blue : white);
	p.setBackground(isSelected ? light_blue : white);

	
	
	JPanel pg = new JPanel();
	
	pg.setLayout( layout );				//1
	layout.setConstraints(pg, constraints);		//2
/**/

	
	pg.add(p);

	return p;
	//return pg;
   }

private Container test_pad(String s, boolean isSelected)
{
	int index;
	int length;
	int lookup;

	lookup = (int) '\n';
	index  = s.indexOf( lookup );
	length = s.length();
//        System.out.println("before split");
	String a[] = s.split("\n");
//        System.out.println("after split" + a[0] + a[1] );
//	System.out.println("index is " + index + " length is " + length);
	return test_pad0(a[0],a[1], isSelected);
	
}

     public Component getListCellRendererComponent(
       JList list,
       Object value,            // value to display
       int index,               // cell index
       boolean isSelected,      // is the cell selected
       boolean cellHasFocus)    // the list and the cell have the focus
     {
	 
         String s = value.toString();
	 
         setText(s);
         //setHorizontalAlignment(LEFT_ALIGNMENT);
	 Container c = test_pad(s,isSelected);

         setIcon((s.length() > 10) ? longIcon : shortIcon);
   	   if (isSelected) {
             setBackground(list.getSelectionBackground());
	       setForeground(list.getSelectionForeground());
	   }
         else {
	       setBackground(list.getBackground());
	       setForeground(list.getForeground());
	   }
	   setEnabled(list.isEnabled());
	   setFont(list.getFont());
         setOpaque(true);
         //return this;
	setLabelFor(c);
         return c;
     }

     public static void main( String s [] )
     {
            String[] data = {"one", "two", "three", "four"};
            JList dataList = new JList(data);
            dataList.setCellRenderer(new MyCellRenderer());

     }
 }

/*
 String[] data = {"one", "two", "three", "four"};
 JList dataList = new JList(data);
 dataList.setCellRenderer(new MyCellRenderer());
 */
