// Fig. 13.14: ListTest.java
// Selecting colors from a JList.
import java.lang.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;

public class ListTest extends JFrame {
   private JList colorList;
   private Container container; 
   private Container sub_container1;
   private GridBagLayout layout;
   private Font f = new Font("Helvetica", Font.PLAIN, 16);
   private Font fb = new Font("Helvetica", Font.BOLD, 14);
   private Font fn = new Font("Helvetica", Font.PLAIN, 12);
   private Color dark_blue = new Color(0,0,128 + 32);
   private Color light_blue =  new Color(128,196,255);
   private Color mid_grey =  new Color(128,128,128);
   private Color light_grey =  new Color(196,196,196);
   private Color white =  new Color(255,255,255);
   private Color orange =  new Color(255,128,0);


  private final String colorNames[] = { 
"CCC" ,
"BBBBBBBBBBB", 
"AAAAAAAAAAAAAAAAAAAAAAAAAAAA", 
};

   private final Color colors[] = { Color.BLACK, Color.BLUE, Color.CYAN, 
      Color.DARK_GRAY, Color.GRAY, Color.GREEN, Color.LIGHT_GRAY, 
      Color.MAGENTA, Color.ORANGE, Color.PINK, Color.RED, Color.WHITE, 
      Color.YELLOW };



   // set up GUI

  private Container menu_panel()
   {
      // create a list with items in colorNames array
      colorList = new JList( colorNames );

//      colorList.setHorizontalAlignment(SwingConstants.LEADING);

      colorList.setVisibleRowCount( colorNames.length );
      
      // do not allow multiple selections
      colorList.setSelectionMode( ListSelectionModel.SINGLE_SELECTION );
     colorList.setCellRenderer(new MyCellRenderer()); 

//////////// 	colorList.setCellRenderer(new MyPanelRenderer());

      // add a JScrollPane containing JList to content pane

        Box horizontal = Box.createHorizontalBox();
        Box vertical = Box.createVerticalBox();
	
	horizontal.add(Box.createHorizontalStrut(25));
	horizontal.add(new JScrollPane( colorList ));
	horizontal.add(Box.createHorizontalStrut(25));

	vertical.add(Box.createVerticalStrut(25));
	vertical.add(horizontal);
	vertical.add(Box.createVerticalStrut(25));

	JPanel sub_container3  = new JPanel();
	sub_container3.setForeground(light_grey);
 	sub_container3.setBackground(light_grey);
 	sub_container3.setLayout( new GridLayout(1,1, 50, 50) );
        sub_container3.add( vertical );
        return sub_container3;
	
   }

 
   public ListTest()
   {

      super( "List Test" );

 
      container = getContentPane();
   
	container.add(     menu_panel()  );



      colorList.addListSelectionListener(

         new ListSelectionListener() {  // anonymous inner class 

            // handle list selection events
            public void valueChanged( ListSelectionEvent event )
            {
               container.setBackground( 
                  colors[ colorList.getSelectedIndex() ] );
            }

         } // end anonymous inner class

      ); // end call to addListSelectionListener

      setSize( 500, 800 ); // size of window
      setVisible( true );

   } // end ListTest constructor


   public static void main( String args[] )
   { 
      ListTest application = new ListTest();
      application.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
   }

} // end class ListTest

/**************************************************************************
 * (C) Copyright 1992-2003 by Deitel & Associates, Inc. and               *
 * Prentice Hall. All Rights Reserved.                                    *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/
