<?xml version="1.0" encoding="UTF-8"?>
<!--
Test XSLT file to transform a .wsi file into a hierarchy with roughly the same structure as the imsmanifest.xml organization we want to create. -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:wcker="http://www.tall.ox.ac.uk/schema/wcker/0.1" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:cp="http://www.imsproject.org/xsd/imscp_rootv1p1p2" xmlns:imsmd="http://www.imsglobal.org/xsd/imsmd_rootv1p2p1" exclude-result-prefixes="#default xsl cp imsmd dc">
    <xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
    <!--
    Start -->
    <xsl:template match="/">
        <outputOrganization>
            <xsl:for-each select="wcker:wizard/wcker:init/wcker:organization">
                <xsl:apply-templates/>
            </xsl:for-each>
        </outputOrganization>
    </xsl:template>
    <!--
    Make an item -->
    <xsl:template match="wcker:item">
        <manifestItem title="{@title}">
            <xsl:apply-templates/>
        </manifestItem>
    </xsl:template>
    <!--
    Create @count copies of the pattern using patternRepeater-->
    <xsl:template match="wcker:itemPattern">
        <xsl:call-template name="patternRepeater">
            <xsl:with-param name="count" select="@count"/>
        </xsl:call-template>
    </xsl:template>
    <!--
    Repeat as needed -->
    <xsl:template name="patternRepeater">
        <xsl:param name="count"/>
        <manifestItem title="{@title}">
            <xsl:apply-templates/>
        </manifestItem>
        <xsl:if test="$count &gt; 1">
            <xsl:call-template name="patternRepeater">
                <xsl:with-param name="count" select="$count -1"/>
            </xsl:call-template>
        </xsl:if>
    </xsl:template>
</xsl:stylesheet>
